#include "winresrc\rc_def.h"
#include "internls\evrythng.h"
#pragma hdrstop
#include <new.h>

// m_data .cpp
// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"
// modul for the data representation
// const char VersionStamp[] = "xx1.13xx";
//! Kommentierung und Aenderungen B. Buss, 2000/2001, HUB IfI

#include "swintrac\swintrac.h"

#include "datavisa\datavisa.h"
#include "datavisa\m_data.h"



extern TMain Main;
//! Kurvendatenbasis
extern LPDataBase lpDBase;

// for data aquisition
extern float PointX[2],PointY[2]; //! zum Aufzeichnen der Mausbewegungen
extern int nMouseAction;
#define XBNorm 80 //! der Rand zur y-Achse
#define YBNorm 60 //! der Rand zur x-Achse
#define MaxInt 1e10 //! gibt MaxIntensitaetswert und MinIntensitaetswert
#define MinInt 1e-5 //! fuer Visualising Options Menu vor
#define Mindypos 200 //! Minimum Ordinatenausdehnung
#define Maxdypos 700 //! Maximum Ordinatenausdehnung
#define Mindxpos 200 //! Minimum Abzissenausdehnung
#define Maxdxpos 700 //! Maximum Abzissenausdehnung
#define tiles_x_achse 5 //! Standard Anzahl Abzissenbeschriftungen
#define tiles_y_achse 5 //! Standard Anzahl Ordinatenbeschriftungen
#define colors 255 //! Anzahl benutzter Farben (256)
#define stdx 500 //! Standardgroesse Koordinatensystemaussschnitt x
#define stdy 500 //! Standardgroesse Koordinatensystemaussschnitt y

static float tilesx=tiles_x_achse;
static float tilesy=tiles_y_achse;
static int scrolldyposmin=Mindypos;
static int scrolldyposmax=Maxdypos;
static int scrolldxposmin=Mindxpos;
static int scrolldxposmax=Maxdxpos;
static int xBorder = XBNorm;
static int yBorder = YBNorm;
static int retval;
static POINT RLArea[41];
static HGDIOBJ gdiobj;
static HBITMAP hBitmap = NULL;
static HCURSOR hCursor,hOldCursor;
//! ::RLdx ist die x-Punkte Ausdehnung
static WORD RLdx = 400;
//! ::RLdy ist die y-Punkte Ausdehnung - einstellbar im
//! Visualising Options Menu
static WORD RLdy = 400;
//! bIncreasePP ist die "groessere Punkte" Einstellmoeglichkeit
//! Visualising Options Menu
static BOOL bIncreasePP = FALSE;
static double clogval;
static double clinval;
static BOOL bAltCoorSystem = FALSE;
static float MaxIntensitaet=MaxInt, MinIntensitaet=MinInt;

// Bezeichner korrespondieren mit den entsprechenden Enum-Typen
const char aOutputType[6][15] =
    {"RL-Bitmap","Raw Matrix",
     "Curve","Number","BarGraph","Histogram"
    };

const char aScaleType[3][15] =
    {"Logarithmic","Linear","User"
    };

typedef struct
{
    double dX,dY,dOmega,dTheta;
    float fDelta,fIntensity;
}
TData;

// #define Debug
//******************************************************************************
//******************************************************************************
//********** Klasse TBitmapSource **********************************************
//******************************************************************************
//! Konstruktor TBitmapSource
TBitmapSource::TBitmapSource(TPlotData *plotwnd)
{
    dateniscreated=FALSE;
    char Ident[] = "AreaScan";
    //! int cnt=0,cnt1=0;
    //! Stellt die Funktionalitaet der Darstellung von Kurven und der Bewertung
    //! dieser Kurven bereit - Klasse TPlotData
    DataWnd = (TPlotData *)plotwnd;
    DataWnd->BSource = this;
    UserFarb=NULL;
    // xBorder = 80; //! der Rand zur y-Achse im Bitmap (alter Wert 40)
    // yBorder = 40; //! der Rand zur x-Achse im Bitmap (alter Wert 26)

    /* dies hier rausgenommen, da eOutputType zu Anfang immer RL-Bitmap und nicht
     wie vorgesehen dem Menueintrag im Modaldialog entspricht! - Fehler 11
     switch(DataWnd->eOutputType)
     {
     case ReciprokeLatticeBitmap: case MatrixBitmap:
     break;
     default:
     DataWnd->eOutputType = ReciprokeLatticeBitmap;
     }
    */
    BMCoorSys = &DataWnd->AltCoorSys;
    *BMCoorSys = DataWnd->CoorSys;
    bAltCoorSystem = TRUE;
    BMCoorSys->zST = Logarithmic;
    BMCoorSys->yST = BMCoorSys->xST = Linear;
    hDIBInfo = NULL;
    hDIBData = NULL;
    hMemPal = NULL;
    //! oben def. static POINT RLArea[41];
    RLArea[0].x = RLArea[0].y = 0;
    RLArea[1] = RLArea[2] = RLArea[3] = RLArea[4] = RLArea[0];

    BereichDef();
    ColorDef();
    ColorTable.nColorRange = colors;

    //! wenn gewuenscht kann sw-Palette im ini-File angegeben werden
	 bGrayScalePalette = GetPrivateProfileInt(Ident,"swPalette",0,GetCFile());
};

//! setzt Variablenfelder farbe[] und ber[]
//! so dass ein linearer Verlauf abhaengig von Min-,MaxIntensitaet
void TBitmapSource::BereichDef(void)
{
    float bereich1,bereich2;
    bereich1=DataWnd->UpperBound-DataWnd->LowerBound;
    bereich1=bereich1/9;
    bereich2=256/9;
    for(int i=0;i<8;i++)
    {
        ber[i]=DataWnd->LowerBound + (i+1)*bereich1;
        farbe[i]=(i+1)*bereich2;
    }
}

//! dies hier entspricht einer Angabe von Leveln im ini-File
//! um Intensitaetsabstufungen im User Falle zu generieren
//! ansonsten werden Defaultwerte gesetzt
//! dies aber nur im Zusammenhang mit Bitmaps sinnvoll
void TBitmapSource::ColorDef(void)
{
    //! schon mal vorinitialisiert, damit nix schief geht
    int i=0,cnt;

    for(cnt=0;cnt<=255;cnt++) ColorTable.ColorMap[cnt]=255;

    //! in ColorTable.ColorMap[0-255] wird jeder Farbe ein bestimmter
    //! Intensitaetswert zugewiesen

    float zaehl=0,bereich1,bereich2;

    bereich1=ber[i]-DataWnd->LowerBound;
    bereich2=farbe[i]-0;
    bereich1=bereich1/bereich2;
    cnt=0;
    for(cnt;cnt<=farbe[i];cnt++)
    {
        ColorTable.ColorMap[cnt]=DataWnd->LowerBound+zaehl*bereich1;
        zaehl++;
    }
    zaehl=0;

    for(i=0;i<7;i++)
    {
        bereich1=ber[i+1]-ber[i];
        bereich2=farbe[i+1]-farbe[i];
        bereich1=bereich1/bereich2;
        cnt=farbe[i];
        for(cnt;cnt<=farbe[i+1];cnt++)
        {
            ColorTable.ColorMap[cnt]=ber[i]+zaehl*bereich1;
            zaehl++;
        }
        zaehl=0;
    }

    i=7;
    bereich1=DataWnd->UpperBound-ber[i];
    bereich2=255-farbe[i];
    bereich1=bereich1/bereich2;
    cnt=farbe[i];
    for (cnt;cnt<=255;cnt++)
    {
        ColorTable.ColorMap[cnt]=ber[i]+zaehl*bereich1;
        zaehl++;
    }
}


//! Destruktor TBitmapSource
TBitmapSource::~TBitmapSource()
{
    if(hDIBData != NULL)
        GlobalFree(hDIBData);
    if(hDIBInfo != NULL)
        GlobalFree(hDIBInfo);
    if(hMemPal != NULL)
        GlobalFree(hMemPal);
    if(::hBitmap)
        DeleteObject(::hBitmap);
    ::hBitmap = NULL;
    bAltCoorSystem = FALSE;
    xBorder = XBNorm;
    yBorder = YBNorm;
};

void TBitmapSource::New(void)
{
    if(hDIBData != NULL)
        GlobalFree(hDIBData);
    hDIBData = NULL;
    if(hDIBInfo != NULL)
        GlobalFree(hDIBInfo);
    hDIBInfo = NULL;
};

//! gibt Darstellungtyp zurueck
//! wird nicht benutzt
/*
TOutputType TBitmapSource::GetType(void)
{
 return DataWnd->eOutputType;
};
*/

/* DIB-Datei lesen */
//! soll ein Bitmapfile einlesen, stuerzt aber ab, weil Screen nicht initialisiert
BOOL TBitmapSource::ProcessBitmapFile(HFILE hStream)
{
    BITMAPINFOHEADER bmInfoHeader;
    LPBITMAPINFO lpBMPInfo;
    int nColors;
    DWORD memsize;
    HPBYTE hpData;
    TScreen& Screen = DataWnd->Screen;

    // File-Header lesen
    _lread(hStream,&BMPFileHdr,sizeof(BMPFileHdr));
    if(BMPFileHdr.bfType != *(UINT*)"BM")
        return FALSE; // Ausstieg bei falschem Marker
    // BITMAPINFOHEADER Struktur einlesen
    _lread(hStream,&bmInfoHeader,sizeof(bmInfoHeader));
    if(bmInfoHeader.biSize!=sizeof(BITMAPINFOHEADER))
        return FALSE; // Ausstieg bei falscher Groee
    // Wenn Anzahl benutzter Farben im Header stehen ...
    if(bmInfoHeader.biClrUsed!=0)
        nColors = (int)bmInfoHeader.biClrUsed; // ...verwenden...
    else
    { // .. sonst einfach aus Bittiefe erechnen
        if(bmInfoHeader.biBitCount != 24)
            nColors = 1 << bmInfoHeader.biBitCount;
        else nColors = 0;
        bmInfoHeader.biClrUsed = nColors;
    }
    // ggf. biSizeImage nachtragen
    GetImageSize();
    // Speicher fuer Bitmapinfo + Farbpalette anfordern
    memsize = sizeof(BITMAPINFO) + (nColors-1)*sizeof(RGBQUAD);
    if(hDIBInfo)
        hDIBInfo = GlobalReAlloc(hDIBInfo,memsize,GMEM_MOVEABLE);
    else
        hDIBInfo = GlobalAlloc(GMEM_MOVEABLE,memsize);
    if(!hDIBInfo)
        return FALSE;
    lpBMPInfo = (LPBITMAPINFO)GlobalLock(hDIBInfo);
    // Header kopieren
    lpBMPInfo->bmiHeader = bmInfoHeader;
    // Farbtabelle lesen
    _lread(hStream,lpBMPInfo->bmiColors,sizeof(RGBQUAD)*nColors);
    // Speicher fuer die eigentliche Bitmap anfordern, einlesen
    if(hDIBData)
        hDIBData = GlobalReAlloc(hDIBData,bmInfoHeader.biSizeImage,GMEM_MOVEABLE);
    else
        hDIBData = GlobalAlloc(GMEM_MOVEABLE,bmInfoHeader.biSizeImage);

    Screen.dx = (int)bmInfoHeader.biWidth;
    Screen.dy = (int)bmInfoHeader.biHeight;

    GlobalUnlock(hDIBInfo);
    if(!hDIBData)
        return FALSE;
    hpData = (HPBYTE)GlobalLock(hDIBData);
    _hread(hStream,hpData,bmInfoHeader.biSizeImage);
    GlobalUnlock(hDIBData);
    DataWnd->eOutputType = MatrixBitmap;
    if(::hBitmap)
        DeleteObject(::hBitmap);
    ::hBitmap = NULL;
    return TRUE;
};

//! berechnet Bytes pro Zeile*Hoehe des Bitmaps = Gesamtgroesse im Speicher
DWORD TBitmapSource::GetImageSize(void)
{
    DWORD nBits;
    LPBITMAPINFOHEADER lpBMPInfoHdr;
    LPBITMAPINFO lpBMPInfo;

    if(!hDIBInfo) return 1;
    lpBMPInfo = (LPBITMAPINFO)GlobalLock(hDIBInfo);
    lpBMPInfoHdr = &lpBMPInfo->bmiHeader;
    nBits = ((lpBMPInfoHdr->biWidth * lpBMPInfoHdr->biBitCount + 31)
             / 32) * 4 ; // Bytes pro Zeile, Aufrunden auf DWords
    nBits *= (DWORD)lpBMPInfoHdr->biHeight+1; //! zur Sicherheit eine Zeile mehr...
    lpBMPInfoHdr->biSizeImage = nBits;
    GlobalUnlock(hDIBInfo);
    return nBits;
};

//! generiere Palette fuer neues Bitmap
LOGPALETTE *TBitmapSource::CreateDefaultPalette(void)
{
    //! char Ident[] = "AreaScan";
    char buf1[256][4];
    int farbanzahl,i;

    farbanzahl = colors+1;

    // einigermaen gleichmaeigverteilte Standardpalette erzeugen
    int size = sizeof(LOGPALETTE)+(farbanzahl)*sizeof(PALETTEENTRY);

    LOGPALETTE *pPal=(LOGPALETTE *)new char[size];
    memset(pPal,0,size);
    pPal->palVersion = 0x300;
    pPal->palNumEntries = farbanzahl;
    if(bGrayScalePalette)
    {
        //! grayscale palette
        for(i=0;i<=255;i++)
        {
            buf1[i][0]=255-i;
            buf1[i][1]=255-i;
            buf1[i][2]=255-i;
            buf1[i][3]=0;
        }
        memcpy(pPal->palPalEntry,buf1,4*farbanzahl);
    }
    //! ansonsten Farbverlauf mit 256 Farben
    else
    {
        buf1[0][0]=255;
        buf1[0][1]=255;
        buf1[0][2]=255;
        buf1[0][3]=0;
        for(i=0;i<=49;i++)
        {
            buf1[1+i][0]=255;
            buf1[1+i][1]=255-5*i;
            buf1[1+i][2]=0;
            buf1[1+i][3]=0;
        }
        for(i=0;i<=49;i++)
        {
            buf1[51+i][0]=255;
            buf1[51+i][1]=0;
            buf1[51+i][2]=5*i;
            buf1[51+i][3]=0;
        }
        for(i=0;i<=49;i++)
        {
            buf1[101+i][0]=255-5*i;
            buf1[101+i][1]=0;
            buf1[101+i][2]=255;
            buf1[101+i][3]=0;
        }
        for(i=0;i<=49;i++)
        {
            buf1[151+i][0]=0;
            buf1[151+i][1]=5*i;
            buf1[151+i][2]=255;
            buf1[151+i][3]=0;
        }
        for(i=0;i<=49;i++)
        {
            buf1[201+i][0]=0;
            buf1[201+i][1]=255;
            buf1[201+i][2]=255-5*i;
            buf1[201+i][3]=0;
        }
        for(i=0;i<=4;i++)
        {
            buf1[251+i][0]=160-10*i*i;
            buf1[251+i][1]=160-10*i*i;
            buf1[251+i][2]=160-10*i*i;
            buf1[251+i][3]=0;
        }

        memcpy(pPal->palPalEntry,buf1,4*farbanzahl);
    }
    return pPal;
};

//! generiert Palette aus DIB (Device independend Bitmap)
LOGPALETTE *TBitmapSource::CreatePaletteFromDIB(void)
{
    // Palette aus DIB erzeugen
    LOGPALETTE *pPalette;
    PALETTEENTRY *pEntry;
    RGBQUAD *pRGB;
    int cnt;
    short nColors;
    LPBITMAPINFO lpBMPInfo;

    lpBMPInfo = (LPBITMAPINFO)GlobalLock(hDIBInfo);
    if(!lpBMPInfo) return NULL;
    nColors = (short)lpBMPInfo->bmiHeader.biClrUsed;
    if(nColors==0)
    {
        GlobalUnlock(hDIBInfo);
        return CreateDefaultPalette();
    }
    pPalette=(LOGPALETTE*)new char[sizeof(LOGPALETTE)+ (nColors-1)*sizeof(PALETTEENTRY)];
    if(pPalette)
    {
        pPalette->palVersion = 0x300;
        pPalette->palNumEntries = nColors;
        pRGB=lpBMPInfo->bmiColors;
        pEntry=pPalette->palPalEntry;
        for(cnt=0;cnt<nColors;cnt++)
        {
            pEntry->peRed = pRGB->rgbRed;
            pEntry->peGreen = pRGB->rgbGreen;
            pEntry->peBlue = pRGB->rgbBlue;
            pEntry->peFlags = 0;
            pRGB++;
            pEntry++;
        }
    }
    GlobalUnlock(hDIBInfo);
    return pPalette;
};

//! fuellt den Header eines Bitmaps mit Farbwerten der Palette
void TBitmapSource::FillBMInfoFromPalette(LOGPALETTE *pPal)
{
    PALETTEENTRY *pEntry;
    RGBQUAD *pRGB;
    int nColors,cnt;
    LPBITMAPINFO lpBMPInfo;

    lpBMPInfo = (LPBITMAPINFO)GlobalLock(hDIBInfo);
    pRGB = lpBMPInfo->bmiColors;
    pEntry = pPal->palPalEntry;
    nColors = min((WORD)lpBMPInfo->bmiHeader.biClrUsed,(WORD)pPal->palNumEntries);
    for(cnt=0;cnt<nColors;cnt++)
    {
        pRGB->rgbRed = pEntry->peRed;
        pRGB->rgbGreen = pEntry->peGreen;
        pRGB->rgbBlue = pEntry->peBlue;
        pRGB++;
        pEntry++;
    }
    GlobalUnlock(hDIBInfo);
};

//! ruft CreatePaletteFromDIB(), ansonsten CreateDefaultPalette()
LOGPALETTE * TBitmapSource::GetPalette(void)
{
    LOGPALETTE *logPal;

    logPal = CreatePaletteFromDIB();
    if(!logPal)
        logPal = CreateDefaultPalette();
    return logPal;
};

//! function creates a device-dependent bitmap (DDB) from a device-independent
//! bitmap (DIB) and, optionally, sets the bitmap bits
HBITMAP TBitmapSource::CreateGDIObject(HDC hdc)
{
    HPALETTE hPal,hDefPal;
    HPBYTE hpData;
    LPBITMAPINFO lpBMPInfo;

    hPal = CreatePalette(GetPalette());
    hDefPal = SelectPalette(hdc,hPal,FALSE);
    hpData = (HPBYTE) GlobalLock(hDIBData);
    lpBMPInfo = (LPBITMAPINFO) GlobalLock(hDIBInfo);
    RealizePalette(hdc);
    ::hBitmap = CreateDIBitmap(hdc,&lpBMPInfo->bmiHeader,CBM_INIT,hpData,lpBMPInfo,DIB_RGB_COLORS);
    SelectPalette(hdc,hDefPal,FALSE);
    DeleteObject(hPal);
    GlobalUnlock(hDIBInfo);
    GlobalUnlock(hDIBData);
    return ::hBitmap;
};

//! gibt zu uebergebener Intensitaet entsprechende Intensitaetsfarbe zurueck
int TBitmapSource::GetColor(float intens)
{
    int ci;
    float fval;
    switch(BMCoorSys->zST)

        //! clogval = ColorTable.nColorRange / log10(BMCoorSys->zMax / BMCoorSys->zMin);
        //! clinval = (BMCoorSys->zMax - BMCoorSys->zMin);
    {
    case Logarithmic:
        if(intens < BMCoorSys->zMin)
            return 0;
        fval = log10(intens / BMCoorSys->zMin) * clogval;
        if(fval > ColorTable.nColorRange)
            return 255; // the Color 255 should be black always

        //! hab hier die zeile reingeschoben, zum runden - Fehler 2
        fval = floor(fval);

        return (int)fval;

    case Linear:
        //! fval = (intens - BMCoorSys->zMin) / clinval; Fehler 4
        //! hier wurden falsche Intesitaetswerte berechnet, da ColorRange nicht beachtet
        fval = ((intens - BMCoorSys->zMin) / clinval)*ColorTable.nColorRange;
        if(fval < 0.0)
            return 0;
        if(fval > ColorTable.nColorRange)
            return 255; // the Color 255 should be black always

        //! hab hier die zeile reingeschoben, zum runden - Fehler 2
        fval = floor(fval);
        return (int)fval;

    case User:

        for(ci = 0;ci <= ColorTable.nColorRange; ci++)
        {
            if(ColorTable.ColorMap[ci] < intens)
                continue;
            return ci;
        }
    }
    return 255; // the Color 255 should be black always;
}
;

//! Bitblock-Transfer von hMemDC (dem gegebenen Quell-DC)
//! zu diesem HDC (dem Ziel-DC) - entspricht der Darstellung eines Bitmaps
void TBitmapSource::DrawBitmap(HDC hdc,int ofsx,int ofsy)
{
    BITMAP bm;
    HDC hMemDC;
    TScreen& Screen = DataWnd->Screen;

    // Bitmap-Handle holen
    if(!::hBitmap)
        ::hBitmap = CreateGDIObject(hdc);
    // Bitmap ausgeben
    hMemDC = CreateCompatibleDC(hdc);
    gdiobj = SelectObject(hMemDC,::hBitmap);
    SetMapMode(hMemDC,GetMapMode(hdc));
    GetObject(::hBitmap,sizeof(BITMAP),(LPSTR)&bm);
    BitBlt(hdc,Screen.x0+ofsx,Screen.y0+ofsy,Screen.dx,Screen.dy,hMemDC,0,0,SRCCOPY);

    // GDI aufraeumen
    DeleteDC(hMemDC);
};

//! ruft bei RL_Bitmap DrawMeasurementArea()
//! berechnet Position der Anordnung der Farblegende
//! setzt Min,MaxIntensitaeten
//! ruft DrawColorTable()
void TBitmapSource::DrawBitmapFrame(HDC hdc)
{
    TScreen& Screen = DataWnd->Screen;

    // Frame zeichnen
    switch(DataWnd->eOutputType)
    {
    case ReciprokeLatticeBitmap:
    case MatrixBitmap:
        DrawMeasurementArea(hdc);
        break;
    }

    // Struktur CTable fuellen
    ColorTable.place.left = Screen.x0 + Screen.dx + 20;
    ColorTable.place.right = ColorTable.place.left + 30;
    ColorTable.place.bottom = Screen.y0-30;
    ColorTable.place.top = ColorTable.place.bottom + ColorTable.nColorRange * 2;
    ColorTable.zMin = BMCoorSys->zMin;
    ColorTable.zMax = BMCoorSys->zMax;
    strcpy(ColorTable.zUnit,"Intensity");
    DrawColorTable(hdc,ColorTable);
};

//! setzt Screen-Variablen, entsprechend der Bildschirmgroesse
//! setzt Units, Orientation, Scaling
void TBitmapSource::SetScreen(HDC hdc,TScreen& screen)
//! hier wird der Screen innerhalb des Koordinatensystems gemeint
{
    SIZE tagS;
    POINT tagP;
    RECT rect;
    int dx,dy;

    TScreen& Screen = DataWnd->Screen;
    // Bestimmen der Ausdehnung in Pixeln des Zeichen-Fensters
    GetClientRect(DataWnd->hWndChild,(LPRECT)&rect);
    // Daten-Bereich festlegen
    //! wenn nicht initialisiert, setzt Standardwerte
    if(!Screen.dx || !Screen.dy)
    {
        Screen.dx = stdx;
        Screen.dy = stdy;
        MessageBox(GetFocus(),"Screen (1)","Message",MBINFO);
    }

    dx = (rect.right - rect.left);
    dy = (rect.bottom - rect.top);
    screen.x0 = 0;
    screen.x1 = dx;
    screen.y0 = 0;
    screen.y1 = dy;

    //! Functions to specify the units, orientation, and scaling that you want
    SetMapMode(hdc,MM_ANISOTROPIC);
    SetWindowExtEx(hdc,dx + xBorder,dy + yBorder,&tagS);
    SetViewportExtEx(hdc,dx + xBorder,-(dy + yBorder),&tagS);
    SetWindowOrgEx(hdc,0,0,&tagP);
    SetViewportOrgEx(hdc,xBorder,dy-yBorder,&tagP);
};

void TBitmapSource::DrawColorTable(HDC hdc,TColorTable &ct)
//! der Name ist irritierend
//! berechnet entsprechende Intensitaeten
//! und gibt die Legende zu den Intensitaeten aus
{
    int cnt,fs = 14;
    int xl,yt,xr,yb,red,green,blue;
    float intens,sf;
    char buf[30];
    LOGPALETTE *pPal;
    LOGFONT lf;
    PALETTEENTRY *pPE;
    HBRUSH hBrush,hOldBrush;
    HPEN hPen,hOldPen;
    HFONT hFont,hOldFont;
    POINT aPoints[5];
    SIZE tagS;

    //! ruft CreatePaletteFromDIB oder im Fehlerfall CreateDefaultPalette
    pPal = GetPalette();

    pPE = pPal->palPalEntry;

    switch(BMCoorSys->zST)
    {
    case Linear:
        sf = (BMCoorSys->zMax - BMCoorSys->zMin) / (float)ct.nColorRange;
        break;
    case Logarithmic:
        sf = (float)ct.nColorRange / log10(BMCoorSys->zMax/BMCoorSys->zMin);
        break;
    }

    // Font selektieren
    memset(&lf,0,sizeof(LOGFONT));
    lf.lfHeight = fs;
    lf.lfWidth = 0;
    lf.lfWeight = 200;
    lf.lfUnderline = FALSE;
    strcpy(lf.lfFaceName,"Times New Roman");
    hFont = CreateFontIndirect(&lf);
    hOldFont = (HFONT)SelectObject(hdc,hFont);
    xl = ct.place.left;
    xr = ct.place.right;

    //! durchlaeuft die for-Schleife fuer alle Farben und
    //! traegt die Intensitaeten in das Rechteck ein

    for(cnt=0;cnt <= ct.nColorRange;cnt++)
    {
        red = pPE[cnt].peRed;
        green = pPE[cnt].peGreen;
        blue = pPE[cnt].peBlue;
        hBrush = CreateSolidBrush(RGB(red,green,blue));
        hPen = CreatePen(PS_SOLID,1,RGB(red,green,blue));

        if(!cnt)
        {
            hOldBrush = (HBRUSH)SelectObject(hdc,hBrush);
            hOldPen = (HPEN)SelectObject(hdc,hPen);
        }

        gdiobj = SelectObject(hdc,hBrush);
        gdiobj = SelectObject(hdc,hPen);

        switch(BMCoorSys->zST)
        {
            //! berechene Intensitaetsverteilung je nachdem ob linear oder
            //! logarithmisch skalierter Verlauf
        case Linear:
            intens = BMCoorSys->zMin + (float)cnt * sf;
            break;
        case Logarithmic:
            intens = pow(10,(float)cnt / sf) * BMCoorSys->zMin;
            break;
            //! hier User Intensitaetsverteilung hinzugefuegt
        case User:
            intens = ct.ColorMap[cnt];
            break;
        }

        if(intens < 10.0) sprintf(buf,"I = %.3f",intens);
        else
            if(intens < 100.0) sprintf(buf,"I = %.2f",intens);
            else
                if(intens < 1000.0) sprintf(buf,"I = %.1f",intens);
                else
                    sprintf(buf,"I > %.0f",intens);

        //! hier angepasst, um Farbkreis als Intensitaetsskala auszugeben
        if (::RLdy<400)
		  {
			  yb = ct.place.bottom + cnt;
			  yt = yb+1;
		  }
		  else
		  {
			  yb = ct.place.bottom + cnt*2;
			  //! yt = (++yb) + bs;
			  yt = yb+2;
		  }

		  //! the rectangle is outlined by using the current pen and filled
		  //! by using the current brush
		  //! zeichne einzelne Intensitaetsstufen
		  Rectangle(hdc,xl,yt,xr,yb);

		  //! schreibe Intensitaeten mit vorher bestimmten Nachkommastellen aus
		  if ((::RLdy<400 && !(cnt%18)) || (::RLdy>=400 &&!(cnt%9)))
		  {
				SetTextAlign(hdc,TA_BOTTOM);
				GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
				TextOut(hdc,xr+8,(yb+yt)/2-tagS.cy/2,(LPSTR)buf,strlen(buf));
				gdiobj = SelectObject(hdc,hOldPen);
				retval = DeleteObject(hPen);
				//! zeichne kleine Orientierungslinie an Intensitaetsskala
				hPen = CreatePen(PS_SOLID,1,RGB(0,0,0));
				aPoints[0].y=aPoints[1].y=(yb+yt)/2;
            aPoints[0].x=xr+5;
            aPoints[1].x=xr;
            Polyline(hdc,aPoints,2);
            SetTextAlign(hdc,TA_TOP);
        }

        //! zum Schluss noch den Rand um die Intensitaetsskala zeichnen
        if(cnt==ct.nColorRange)
        {
            gdiobj = SelectObject(hdc,hOldPen);
            retval = DeleteObject(hPen);
				hPen = CreatePen(PS_SOLID,1,RGB(0,0,0));
            aPoints[0].x=aPoints[1].x=aPoints[4].x=xl;
            aPoints[0].y=aPoints[3].y=aPoints[4].y=ct.place.bottom;
            aPoints[1].y=aPoints[2].y=yt;
            aPoints[2].x=aPoints[3].x=xr;
            Polyline(hdc, aPoints, sizeof(aPoints) / sizeof(POINT));
		  }
        gdiobj = SelectObject(hdc,hOldBrush);
        retval = DeleteObject(hBrush);
        gdiobj = SelectObject(hdc,hOldPen);
        retval = DeleteObject(hPen);
    }
	 //! while-Schleife zu Ende

	 gdiobj = SelectObject(hdc,hOldFont);
	 retval = DeleteObject(hFont);
};

//! generiere MatrixBitmap
void TBitmapSource::GenerateAngleSpaceBitmap(void)
{
	 char Msg[MaxString];
	 TCurve* Scan = lpDBase->GetCurve(0);
	 // TCurve* ScanRep = lpDBase->GetScanReport();
	 UINT nScanNumber = lpDBase->GetCNumber();
	 // UINT nPointNumber = Scan->GetPNumber();
	 //! definiert in comhead.h typedef struct {float x, y;int Ord;} TKSystem[4];
	 TKSystem KS_AR;
	 HPBYTE hpData;
	 DWORD addr;
	 int cnt,cx,cy,ival;
	 float fIntens,dd;
	 float imax=MinIntensitaet,imin=MaxIntensitaet;
	 TScreen& Screen = DataWnd->Screen;

	 if(DataWnd->eOutputType != MatrixBitmap) return;
	 //****************************************************************************
	 //**** Bitmap formatieren ****************************************************
	 // set waiting cursor
	 hCursor = LoadCursor(NULL,IDC_WAIT);
	 hOldCursor = SetCursor(hCursor);
	 // get pointer to data area
	 hpData = (HPBYTE)GlobalLock(hDIBData);
	 if(!hpData)
	 {
		  MessageBox(GetFocus(),"Cannot create memory object (2)","Message",MBINFO);
		  return;
	 }
	 // inquire intensity range
	 //! ermittle Werte fuer Statuszeile - Intensity Range
	 //! durchlaufe alle Scans und ermittle min und max...
	 if(1 < nScanNumber)
	 {
		  int cy = nScanNumber;
		  while(cy--)
		  {
				Scan = lpDBase->GetCurve(cy);
				imin = min(Scan->Min[P_Y],imin);
				imax = max(Scan->Max[P_Y],imax);
		  }
	 }
	 else
		  //! hier fehlte vorher die Klammerung..., so dass imax sonst immer 1000
		  //! Fehler3
	 {
		  imin = 0.1;
		  imax = 1000.0;
	 }

#ifdef GermanVersion
	 sprintf(Msg,"Intensittsbereich [%.3f-->%.3f] ",imin,imax);
#else
	 sprintf(Msg,"Intensity Range [%.3f-->%.3f] ",imin,imax);
#endif

	 // compute cacheval for colormap
	 switch(BMCoorSys->zST)
	 {
	 case Logarithmic:
		  clogval = ColorTable.nColorRange / log10(BMCoorSys->zMax / BMCoorSys->zMin);
		  break;
	 case Linear:
	 case User:
		  clinval = (BMCoorSys->zMax - BMCoorSys->zMin);
	 }
	 // Inquire measurement area
	 DataWnd->SetMeasurementArea(KS_AR);
	 // sort ranges

	 //! Suche nach kleinstem KS_AR[*].y
	 for(cnt = 1,ival = 0;cnt < 4;cnt++)
		  if(KS_AR[cnt].y < KS_AR[ival].y) ival = cnt;
	 BMCoorSys->yMin = KS_AR[ival].y;

	 //! Suche nach groesstem KS_AR[*].y
	 for(cnt=1,ival = 0;cnt < 4;cnt++)
		  if(KS_AR[cnt].y > KS_AR[ival].y) ival = cnt;
	 BMCoorSys->yMax = KS_AR[ival].y;

	 //! Suche nach kleinstem KS_AR[*].x
	 for(cnt=1,ival = 0;cnt<4;cnt++)
		  if(KS_AR[cnt].x < KS_AR[ival].x) ival = cnt;
	 BMCoorSys->xMin = KS_AR[ival].x;

	 //! Suche nach groesstem KS_AR[*].x
	 for(cnt=1,ival = 0;cnt<4;cnt++)
		  if(KS_AR[cnt].x > KS_AR[ival].x) ival = cnt;
	 BMCoorSys->xMax = KS_AR[ival].x;

	 // compute scaling factors
	 BMCoorSys->xSF = (BMCoorSys->xMax - BMCoorSys->xMin)/Screen.dx;
	 BMCoorSys->ySF = (BMCoorSys->yMax - BMCoorSys->yMin)/Screen.dy;

	 //! ab hier Berechnung des MatrixBitmap umgestellt, berechnet sich jetzt aehnlich
	 //! wie ein RL-Bitmap

	 addr = cy = 0;
	 TCurve* ScanRep = lpDBase->GetScanReport();

	 //** draw points in bitmap source
	 ScanRep->FastOpen();

	 float fOmega,fThetaPsd,fTheta;
	 int rmx,rmy;
	 BYTE nColor;
	 BOOL bOutsideData = FALSE;

	 UINT nPointNumber = Scan->GetPNumber();
	 DWORD MaxAddr = GetImageSize();

//!	 MaxAddr -= Screen.dx + 1;
	 //! durchlaufe alle Zeilen


	 for(cy = 0;cy < nScanNumber;cy++)
	 {
		  Scan = lpDBase->GetCurve(cy);
		  Scan->SetPP(0);
		  Scan->FastOpen();
		  ScanRep->SetPP(cy);

		  //! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
		  ScanRep->FastPGet(fOmega,dd,dd);
		  fTheta = DataWnd->GetThetaOffset(cy);
		  nPointNumber = Scan->GetPNumber();
		  if(!(cy % 30))
		  {
#ifdef GermanVersion
				sprintf(Msg,"Zeile %d mit %d Spalten",cy,nPointNumber);
#else
				sprintf(Msg,"Row %d with %d Columns",cy,nPointNumber);
#endif
				SetInfo(Msg);
		  }
		  //! durchlaufe alle Spalten
		  for(cx = 0;cx < nPointNumber;cx++)
		  {

				//! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
				Scan->FastPGet(fThetaPsd,fIntens,dd);
				//! hier mit DataWnd->CoorSys.xMin gerechnet, da Theta und der ThetaOffset
				//! nicht in BMCoorSyseinheiten umgerechnet wurden und sich somit
				//! auf ein altes Koordinatensystem beziehen
				//! berechne Koordinaten des Pixels
				if (!DataWnd->VisualDB.bPsd) fTheta=0;
				rmx = (fThetaPsd+fTheta-BMCoorSys->xMin) / BMCoorSys->xSF;
				rmy = (fOmega - BMCoorSys->yMin) / BMCoorSys->ySF;

				//! manchmal wird rmx>Screen.dx - Rundungsfehler!
				//! manchmal wird rmy>Screen.dy - Rundungsfehler!
				if (rmx>Screen.dx) rmx=Screen.dx;
				if (rmy>Screen.dy) rmy=Screen.dy;

				//! berechne Adresse des Pixels im Bitmap
				addr = rmx + (DWORD)rmy * Screen.dx;
				//! hole Farbe des Pixels fuer aktuelle Intensitaet
				nColor = (short)GetColor(fIntens);

				if(nColor == 0)
					 continue;

				if(addr > MaxAddr)
				{
					 sprintf(Msg,"rmx %d rmy %d dx %d dy %d Omega %f Theta %f",rmx,rmy,Screen.dx,Screen.dy,fOmega,fTheta+fThetaPsd);
					 MessageBox(GetFocus(),Msg,"Fehler/Error",MB_OK | MB_ICONHAND);
					 bOutsideData = TRUE;
					 continue;
				}
				hpData[addr] = nColor;
				//! falls "Groessere Punkte" gewaehlt, wird Punkt kuenstlich vergroessert
				if(!::bIncreasePP) continue;
				if(((addr+1) > MaxAddr) || ((addr+Screen.dx) > MaxAddr) ||
						  ((addr-1) > MaxAddr) || ((addr-Screen.dx) > MaxAddr) )
					 continue;
				hpData[addr-1] = nColor;
				hpData[addr+1] = nColor;
				hpData[addr - Screen.dx] = nColor;
				hpData[addr + Screen.dx] = nColor;
		  }
		  Scan->FastClose();
	 }
#ifdef GermanVersion
	 sprintf(Msg,"Intensittsbereich [%.3f-->%.3f] ",imin,imax);
	 if(bOutsideData) strcat(Msg,"Bereichsberschreitung !");
#else
	 sprintf(Msg,"Intensity Range [%.3f-->%.3f] ",imin,imax);
	 if(bOutsideData) strcat(Msg,"Overflow !");
#endif

    ScanRep->FastClose();
    SetCursor(::hOldCursor);
    SetInfo(Msg);
    GlobalUnlock(hDIBData);
};

//! falls RL-Bitmapdarstellung, berechnet und zeichnet
//! das untersuchte Messgebiet im den reziproken Raum
void TBitmapSource::DrawMeasurementArea(HDC hdc)
{
    int dx,dy,cnt,ival;
    float dARx,dARy,mf;
    float fOmega,fTheta,offset;
    //! definiert in comhead.h typedef struct {float x, y;int Ord;} TKSystem[4];
    TKSystem KS_AR,KS_RL;
    TCoorSystem coorsys;
    HPEN hOldPen,hPenDot;
    POINT egde[5];
    float factor = M_PI / (0.5 * Main.WaveLength);
    TScreen& Screen = DataWnd->Screen;

    //! zeichnen 2 Hilfslinien, um Measurementarea abzugrenzen
    if (DataWnd->eOutputType==MatrixBitmap)
    {
        hPenDot = CreatePen(PS_DOT,1,RGB(255,0,0));
        hOldPen = (HPEN)SelectObject(hdc,hPenDot);
		  offset=DataWnd->VisualDB.dThetaMinLast-DataWnd->AltCoorSys.xMin;
		  offset=offset/BMCoorSys->xSF;
        egde[0].x = Screen.x0;
        egde[0].y = Screen.y0;
        egde[1].x = Screen.x0+offset;
        egde[1].y = Screen.y0+Screen.dy;
        Polyline(hdc,egde,2);
        egde[0].x = Screen.x0+Screen.dx-offset;
        egde[0].y = Screen.y0;
        egde[1].x = Screen.x0+Screen.dx;
        egde[1].y = Screen.y0+Screen.dy;
        Polyline(hdc,egde,2);
        gdiobj = SelectObject(hdc,hOldPen);
        retval = DeleteObject(hPenDot);
    }
    else
    {
        DataWnd->SetMeasurementArea(KS_AR);
        if(!::hBitmap)
        {
            //! ::RLdy ist die y-Punkte Ausdehnung im Visualising Options Menu
            Screen.dy = ::RLdy = max((WORD)0,min((WORD)700,::RLdy));
            //! ::RLdx ist die x-Punkte Ausdehnung
            Screen.dx = ((::RLdx + 3) / 4) * 4;

            DataWnd->SetRanges();
            BMCoorSys->zMax = DataWnd->UpperBound;
            BMCoorSys->zMin = DataWnd->LowerBound;
            switch(BMCoorSys->zST)
            {
            case Logarithmic:
                clogval = ColorTable.nColorRange / log10(BMCoorSys->zMax / BMCoorSys->zMin);
                break;
            case Linear:
            case User:
                clinval = (BMCoorSys->zMax - BMCoorSys->zMin);
                break;
            }
            // compute new Coordinate system ranges
            for(cnt=0;cnt<4;cnt++)
            {
                KS_RL[cnt].x = ArToRLx (KS_AR[cnt].y,KS_AR[cnt].x);
                KS_RL[cnt].y = ArToRLy (KS_AR[cnt].y,KS_AR[cnt].x);
                KS_RL[cnt].Ord = -1;
            }
            // sort ranges
            for(cnt=1,ival=0;cnt<4;cnt++)
                if(KS_RL[cnt].y < KS_RL[ival].y) ival = cnt;

            BMCoorSys->yMin = KS_RL[ival].y;

            for(cnt=1,ival=0;cnt<4;cnt++)
                if(KS_RL[cnt].y > KS_RL[ival].y) ival = cnt;

            BMCoorSys->yMax = KS_RL[ival].y;

            for(cnt=1,ival=0;cnt<4;cnt++)
                if(KS_RL[cnt].x < KS_RL[ival].x) ival = cnt;

            BMCoorSys->xMin = KS_RL[ival].x;

            for(cnt=1,ival=0;cnt<4;cnt++)
                if(KS_RL[cnt].x > KS_RL[ival].x) ival = cnt;

            BMCoorSys->xMax = KS_RL[ival].x;
            // compute scaling factors
            BMCoorSys->xSF = (BMCoorSys->xMax - BMCoorSys->xMin)/ Screen.dx;
            BMCoorSys->ySF = (BMCoorSys->yMax - BMCoorSys->yMin)/ Screen.dy;
            //** fix scale relation
            if(!DataWnd->bXY_Scaling)
            {
                if(BMCoorSys->xSF < BMCoorSys->ySF) BMCoorSys->xSF = BMCoorSys->ySF;
                else BMCoorSys->ySF = BMCoorSys->xSF;
            }
            //! falls Aenderung von Werten, muss neu berechnet werden
            BMCoorSys->xMax=BMCoorSys->xMin+Screen.dx*BMCoorSys->xSF;
            BMCoorSys->yMax=BMCoorSys->yMin+Screen.dy*BMCoorSys->ySF;

            //** center bitmap
            mf = (BMCoorSys->xMax - BMCoorSys->xMin) / BMCoorSys->xSF;
            mf = (Screen.dx - mf) / 2 * BMCoorSys->xSF;
            BMCoorSys->xMin -= mf;
            BMCoorSys->xMax -= mf;
            mf = (BMCoorSys->yMax - BMCoorSys->yMin) / BMCoorSys->ySF;
            mf = (Screen.dy - mf) / 2 * BMCoorSys->ySF;
            BMCoorSys->yMin -= mf;
            BMCoorSys->yMax -= mf;
            factor = M_PI / (0.5 * Main.WaveLength);
            BMCoorSys->xSF *= factor;
            BMCoorSys->ySF *= factor;
            BMCoorSys->xMin *= factor;
            BMCoorSys->xMax *= factor;
            BMCoorSys->yMin *= factor;
            BMCoorSys->yMax *= factor;
        }
        // access the first coordinate structure to get angle koordinate system
        coorsys = *BMCoorSys;
        factor = (0.5 * Main.WaveLength) / M_PI;
        coorsys.xSF *= factor;
        coorsys.ySF *= factor;
        coorsys.xMin *= factor;
        coorsys.xMax *= factor;
        coorsys.yMin *= factor;
        coorsys.yMax *= factor;
        // compute frame
        for(int pp=0;pp<4;pp++)
        {
            dARx = KS_AR[(pp+1) % 4].x - KS_AR[pp].x;
            dARy = KS_AR[(pp+1) % 4].y - KS_AR[pp].y;
            switch(pp)
            {
            case 0:
                dx = dy = 1;
                break;
            case 1:
                dx = 1;
                dy = -1;
                break;
            case 2:
                dx = dy = -1;
                break;
            case 3:
                dx = -1;
                dy = 1;
                break;
            }
            for(cnt = pp*10;cnt < (pp+1) * 10;cnt++)
            {
                fOmega = KS_AR[pp].y + (cnt % 10) * (dARy / 10.0);
                fTheta = KS_AR[pp].x + (cnt % 10) * (dARx / 10.0);
                RLArea[cnt].x = (ArToRLx (fOmega,fTheta) - coorsys.xMin) / coorsys.xSF;
                RLArea[cnt].y = (ArToRLy (fOmega,fTheta) - coorsys.yMin) / coorsys.ySF;
                RLArea[cnt].x += dx;
                RLArea[cnt].y += dy;
            }
        }
        RLArea[40] = RLArea[0];
        hPenDot = CreatePen(PS_DOT,1,RGB(255,0,0));
        hOldPen = (HPEN)SelectObject(hdc,hPenDot);
        Polyline(hdc,RLArea,41);
        gdiobj = SelectObject(hdc,hOldPen);
        retval = DeleteObject(hPenDot);
    }
};

//! generiere RL-Bitmap
void TBitmapSource::GenerateRLBitmap(void)
{
    int cnt,cx,cy,rlx,rly,ival,i,j;
    //! erste Kurve holen
    TCurve* Scan = lpDBase->GetCurve(0);
    //! ScanReport holen
    TCurve* ScanRep = lpDBase->GetScanReport();
    //! Anzahl der Scans holen
    UINT nScanNumber = lpDBase->GetCNumber();
    //! Anzahl der Punkte einer Kurve holen
    UINT nPointNumber = Scan->GetPNumber();
    HPBYTE hpData;
	 DWORD addr,MaxAddr = GetImageSize();
	 char Msg[MaxString];
	 float fOmega,fThetaPsd,fTheta,fIntens,dd,mf;
	 TKSystem KS_RL,KS_AR;
	 double fome,fthe,factor;
	 BYTE nColor;
	 BOOL bOutsideData = FALSE;
	 TScreen& Screen = DataWnd->Screen;

	 //! nur bei richtigem Darstellungstyp weitermachen
	 if(DataWnd->eOutputType != ReciprokeLatticeBitmap) return;
	 //****************************************************************************
	 //**** Bitmap formatieren ****************************************************
	 // set waiting cursor
	 hCursor = LoadCursor(NULL,IDC_WAIT);
	 hOldCursor = SetCursor(hCursor);
	 //! Speicher fuer Bitmap reservieren
	 // get pointer to data area
	 hpData = (HPBYTE)GlobalLock(hDIBData);
	 if(!hpData)
	 {
		  MessageBox(GetFocus(),"Cannot create memory object (2)","Message",MBINFO);
		  return;
	 }
	 // inquire intensity range
	 float imax=MinIntensitaet,imin=MaxIntensitaet;
	 if(1 < nScanNumber)
	 {
		  int cy = nScanNumber;
		  while(cy--)
		  {
				Scan = lpDBase->GetCurve(cy);
				imin = min(Scan->Min[P_Y],imin);
				imax = max(Scan->Max[P_Y],imax);
		  }
	 }
	 else
		  imin = imax = 0.0;
#ifdef GermanVersion
	 sprintf(Msg,"Intensittsbereich [%.3f-->%.3f] ",imin,imax);
#else
	 sprintf(Msg,"Intensity Range [%.3f-->%.3f] ",imin,imax);
#endif

	 // compute cacheval for colormap
	 switch(BMCoorSys->zST)
	 {
	 case Logarithmic:
		  clogval = ColorTable.nColorRange / log10(BMCoorSys->zMax / BMCoorSys->zMin);
		  break;
	 case Linear:
	 case User:
		  clinval = (BMCoorSys->zMax - BMCoorSys->zMin);
	 }
	 // transformate data
	 // KS_AR,ArToRLx (x,y) : "x" means "theta" and "y" means "omega"
	 // compute new Coordinate system ranges

	 DataWnd->SetMeasurementArea(KS_AR);

	 for(cnt=0;cnt<4;cnt++)
	 {
		  KS_RL[cnt].x = ArToRLx (KS_AR[cnt].y,KS_AR[cnt].x);
		  KS_RL[cnt].y = ArToRLy (KS_AR[cnt].y,KS_AR[cnt].x);
		  KS_RL[cnt].Ord = -1;
	 }

	 // sort ranges
	 //! Suche nach kleinstem KS_RL[*].y
	 for(cnt=1,ival=0;cnt<4;cnt++)
		  if(KS_RL[cnt].y < KS_RL[ival].y) ival = cnt;
	 BMCoorSys->yMin = KS_RL[ival].y;


	 //! Suche nach groesstem KS_RL[*].y
	 for(cnt=1,ival=0;cnt<4;cnt++)
		  if(KS_RL[cnt].y > KS_RL[ival].y) ival = cnt;
	 BMCoorSys->yMax = KS_RL[ival].y;


	 //! Suche nach kleinstem KS_RL[*].x
	 for(cnt=1,ival=0;cnt<4;cnt++)
		  if(KS_RL[cnt].x < KS_RL[ival].x) ival = cnt;
	 BMCoorSys->xMin = KS_RL[ival].x;


	 //! Suche nach groesstem KS_RL[*].x
	 for(cnt=1,ival=0;cnt<4;cnt++)
		  if(KS_RL[cnt].x > KS_RL[ival].x) ival = cnt;
	 BMCoorSys->xMax = KS_RL[ival].x;


	 //** compute scaling factors
	 BMCoorSys->xSF = (BMCoorSys->xMax - BMCoorSys->xMin)/Screen.dx;
	 BMCoorSys->ySF = (BMCoorSys->yMax - BMCoorSys->yMin)/Screen.dy;
	 if(!DataWnd->bXY_Scaling)
	 {
		  //** fix scale relation
		  if(BMCoorSys->xSF < BMCoorSys->ySF)
				BMCoorSys->xSF = BMCoorSys->ySF;
		  else
				BMCoorSys->ySF = BMCoorSys->xSF;
	 }
	 //! falls Aenderung von Werten, muss neu berechnet werden
	 BMCoorSys->xMax=BMCoorSys->xMin+Screen.dx*BMCoorSys->xSF;
	 BMCoorSys->yMax=BMCoorSys->yMin+Screen.dy*BMCoorSys->ySF;

	 //** center bitmap
	 mf = (BMCoorSys->xMax - BMCoorSys->xMin) / BMCoorSys->xSF;
	 mf = (Screen.dx - mf) / 2 * BMCoorSys->xSF;
	 BMCoorSys->xMin -= mf;
	 BMCoorSys->xMax -= mf;
	 mf = (BMCoorSys->yMax - BMCoorSys->yMin) / BMCoorSys->ySF;
	 mf = (Screen.dy - mf) / 2 * BMCoorSys->ySF;
	 BMCoorSys->yMin -= mf;
	 BMCoorSys->yMax -= mf;

	 //** draw points in bitmap source
	 ScanRep->FastOpen();
//!	 MaxAddr -= Screen.dx + 1;

	 //! hole den Filename der aktuellen Daten
	 strcpy(Msg,DataWnd->GetFileName());
	 //! Vergleich alter Filename - neuer Filename
	 int filevgl=strcmp(Fileold,Msg);
	 //! generiere neues "Daten"feld, wenn ...
	 if (!dateniscreated || Screen.dy!=dyold || Screen.dx!=dxold || filevgl!=0)
	 {
		  //! wenn "Daten"feld existiert, dann loeschen
		  if(dateniscreated)
		  {
				for (i=0;i<dyold+1;i++)
					 delete[] daten[i]; //! SCHRITT 1: SPALTEN LOESCHEN
				delete[] daten; //! Schritt 2: ZEILEN LOESCHEN
		  }

		  try
		  {
				//! SCHRITT 1: ZEILEN.
				daten=new TBMContens*[Screen.dy+1];
				//! SCHRITT 2: SPALTEN.
				for(int j=0;j<Screen.dy+1;j++) daten[j]=new TBMContens[Screen.dx+1];
		  }
		  catch (xalloc)
		  {
				//! DIESEN BLOCK NUR DURCHLAUFEN, WENN xalloc EINTRITT.
				MessageBox(GetFocus(),"Speicherreservierung nicht mglich!","Meldung",MBINFO );
				exit(-1);
		  }

		  for (i = 0; i<Screen.dy+1; i++)
				for (j = 0; j<Screen.dx+1; j++)
				{
					 //! IRGENDEINE INITIALISIERUNG
					 daten[i][j].omega=i*i-j*j;
					 daten[i][j].theta=i*i-j*j;
				}
		  //! alte x-Bildaufloesung speichern
		  dxold=Screen.dx;
		  //! alte y-Bildaufloesung speichern

		  dyold=Screen.dy;
		  //! auf FALSE setzen, weil "Daten"feld neu initialisiert werden muss
		  dateniscreated=FALSE;
		  //! alten Filenamen speichern
		  strcpy(Fileold,DataWnd->GetFileName());
	 }
	 //! durchlaufe alle Zeilen
	 for(cy = 0;cy < nScanNumber;cy++)
	 {
		  Scan = lpDBase->GetCurve(cy);
		  Scan->SetPP(0);
		  Scan->FastOpen();
		  ScanRep->SetPP(cy);

		  //! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
		  ScanRep->FastPGet(fOmega,dd,dd);
//! diese Unterscheidung, da 0-dim. andere Datenbasisspeicherung als
//! 1-dim Areascans (ThetaOffset mitgespeichert/nichtgespeichert)
		  if (DataWnd->VisualDB.bPsd) fTheta = DataWnd->GetThetaOffset(cy);
		  else fTheta=0;

		  nPointNumber = Scan->GetPNumber();
		  if(!(cy % 30))
		  {
#ifdef GermanVersion
				sprintf(Msg,"Zeile %d mit %d Spalten",cy,nPointNumber);
#else
				sprintf(Msg,"Row %d with %d Columns",cy,nPointNumber);
#endif
				SetInfo(Msg);
		  }
		  //! durchlaufe alle Spalten
		  for(cx = 0;cx < nPointNumber;cx++)
		  {

				//! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
				Scan->FastPGet(fThetaPsd,fIntens,dd);
				//! Farbe des Pixels fuer die aktuelle Intensitaet holen
				nColor = (short)GetColor(fIntens);
				//! nach RAD transformieren, weil COS/SIN nur dort definiert

				fthe=DegToRad(fTheta+fThetaPsd);
				fome=DegToRad(fOmega);

				if(nColor==0 && dateniscreated) continue;

				//! in den reziproken Raum transformieren
				rlx = (ArToRLx (fome,fthe) - BMCoorSys->xMin) / BMCoorSys->xSF;
				rly = (ArToRLy (fome,fthe) - BMCoorSys->yMin) / BMCoorSys->ySF;

				//! manchmal wird rlx>Screen.dx - Rundungsfehler!
				//! manchmal wird rly>Screen.dy - Rundungsfehler!
				if (rlx>Screen.dx) rlx=Screen.dx;
				if (rly>Screen.dy) rly=Screen.dy;

				//! Adresse des Pixels im Bitmap berechnen
				addr = rlx + (DWORD)rly * Screen.dx;
				//! falls Adresse ausserhalb des Bitmaps liegt

				if(addr > MaxAddr)
				{
					 bOutsideData = TRUE;
					 continue;
				}
				//! beim ersten Durchlauf "datenarray" aktualisieren
				if (!dateniscreated)
				{
					 if (rlx>Screen.dx || rly>Screen.dy || rlx<0 || rly<0)
					 {
						  bOutsideData=TRUE;
						  continue;
					 }
					 //! "Daten"feld neu initialisieren
					 daten[rly][rlx].omega=fOmega;
					 daten[rly][rlx].theta=fThetaPsd;
				}

				hpData[addr] = nColor;
				if(!::bIncreasePP) continue;
				if( ((addr+1) > MaxAddr) || ((addr+Screen.dx) > MaxAddr) ||
						  ((addr-1) > MaxAddr) || ((addr-Screen.dx) > MaxAddr) )
					 continue;
				hpData[addr-1] = nColor;
				hpData[addr+1] = nColor;
				hpData[addr - Screen.dx] = nColor;
				hpData[addr + Screen.dx] = nColor;
		  }
		  Scan->FastClose();
	 }
	 // nach erstmaligen Durchlauf der Schleifen ist "datenarray" initialisiert
	 dateniscreated=TRUE;

#ifdef GermanVersion
	 sprintf(Msg,"Intensittsbereich [%.3f-->%.3f] ",imin,imax);
	 if(bOutsideData) strcat(Msg,"Bereichsberschreitung !");
#else
	 sprintf(Msg,"Intensity Range [%.3f-->%.3f] ",imin,imax);
	 if(bOutsideData) strcat(Msg,"Overflow !");
#endif

	 ScanRep->FastClose();
    factor = M_PI / (0.5 * Main.WaveLength);
    BMCoorSys->xSF *= factor;
    BMCoorSys->ySF *= factor;
    BMCoorSys->xMin *= factor;
    BMCoorSys->xMax *= factor;
    BMCoorSys->yMin *= factor;
    BMCoorSys->yMax *= factor;
    SetCursor(::hOldCursor);
    SetInfo(Msg);
    GlobalUnlock(hDIBData);
};

//! generiert den Header fuer ein Bitmap, setzt Koordinatensystem und Screen
void TBitmapSource::FormatDBaseToBitmapSource(void)
{
    //! char Ident[] = "AreaScan";
    int farbanzahl;

    LPBITMAPINFOHEADER lpBMPInfoHdr;
    LPBITMAPINFO lpBMPInfo;
    LOGPALETTE *palette;
    DWORD dwSize;
    TCurve* Scan = lpDBase->GetCurve(0);
    //! TCurve* ScanRep = lpDBase->GetScanReport();
    UINT nScanNumber = lpDBase->GetCNumber();
    UINT nPointNumber = Scan->GetPNumber();
    TScreen& Screen = DataWnd->Screen;
    //! wenn Bitmap existiert -> loeschen
    if(::hBitmap)
        DeleteObject(::hBitmap);
    ::hBitmap = NULL;
    //! wenn mehr als 2 Scankurven oder mehr als 2 Punkte in der Kurve
    if((2 > nScanNumber) || (2 > nPointNumber))
    {
        //! Screen-Anpassung in Fkt. CanClose() eingebaut - Fehler 12
        //! Screen.dx = (Screen.x1 - Screen.x0) * 0.8;
        //! Screen.dy = (Screen.y1 - Screen.y0) * 0.9;
        DataWnd->SetRanges();
        DataWnd->AltCoorSys = DataWnd->CoorSys;
        // compute scaling factors
        BMCoorSys->xSF = (BMCoorSys->xMax - BMCoorSys->xMin);
        BMCoorSys->ySF = (BMCoorSys->yMax - BMCoorSys->yMin);
        BMCoorSys->xSF = BMCoorSys->xSF / Screen.dx;
        BMCoorSys->ySF = BMCoorSys->ySF / Screen.dx;
        return;
    }

    // inquire measurement Ranges
    DataWnd->SetRanges();
    DataWnd->AltCoorSys = DataWnd->CoorSys;
    BMCoorSys->xST = BMCoorSys->yST = Linear;
    if(BMCoorSys->xMin <= 0.0)
        BMCoorSys->xMin = 0.0001;
    if(BMCoorSys->yMin <= 0.0)
        BMCoorSys->yMin = 0.0001;

    farbanzahl = colors+1;

    //******** create header for device independend bitmap ***********************
    dwSize = sizeof(BITMAPINFO) + (farbanzahl)*sizeof(RGBQUAD);
    if(hDIBInfo)
        //! the GlobalReAlloc function changes the size or attributes
        //! of a specified global memory object
        hDIBInfo = GlobalReAlloc(hDIBInfo,dwSize,GMEM_MOVEABLE);
    else
        hDIBInfo = GlobalAlloc(GMEM_MOVEABLE,dwSize);
    if(!hDIBInfo)
    {
        MessageBox(GetFocus(),"Cannot create memory object (1)","Message",MBINFO);
        return;
    }
    lpBMPInfo = (LPBITMAPINFO)GlobalLock(hDIBInfo);
    lpBMPInfoHdr = &lpBMPInfo->bmiHeader;
    lpBMPInfoHdr->biSize = sizeof(BITMAPINFOHEADER);
    lpBMPInfoHdr->biPlanes = 1;
    lpBMPInfoHdr->biBitCount = 8;
    lpBMPInfoHdr->biSizeImage = 0; // Because BI_RGB
    lpBMPInfoHdr->biCompression = BI_RGB;
    lpBMPInfoHdr->biXPelsPerMeter = lpBMPInfoHdr->biYPelsPerMeter = 0;
    lpBMPInfoHdr->biClrUsed = farbanzahl;
    lpBMPInfoHdr->biClrImportant = 0;
    // Palette bereitstellen
    palette = CreateDefaultPalette();
    FillBMInfoFromPalette(palette);
    //************ compute bitmap size ****************
    switch(DataWnd->eOutputType)
    {
    case ReciprokeLatticeBitmap:
        //! ::RLdy ist die y-Punkte Ausdehnung im Visualising Options Menu
        Screen.dy = ::RLdy = max((WORD)0,min((WORD)800,::RLdy));
        //! ::RLdx ist die x-Punkte Ausdehnung
        Screen.dx = ((::RLdx + 3) / 4) * 4;
        lpBMPInfoHdr->biWidth = Screen.dx;
        lpBMPInfoHdr->biHeight= Screen.dy;
        break;

    case MatrixBitmap:
        //! Groesse x-Achse gleich der Anzahl der Kurvenpunkte
        //! ::RLdy ist die y-Punkte Ausdehnung im Visualising Options Menu
        Screen.dy = ::RLdy = max((WORD)0,min((WORD)800,::RLdy));
        //! ::RLdx ist die x-Punkte Ausdehnung
        Screen.dx = ((::RLdx + 3) / 4) * 4;
        lpBMPInfoHdr->biWidth = Screen.dx;
        lpBMPInfoHdr->biHeight= Screen.dy;
        break;

    default:
        MessageBox(GetFocus(),"Unknown OutputType","Message",MBINFO);
    }
    // allocate memory for bitmap bits
    if(hDIBData)
        GlobalFree(hDIBData);
    hDIBData = GlobalAlloc(GHND,GetImageSize());
#ifdef GermanVersion
    SetInfo("Daten in ein Bitmap wandeln...");
#else
    SetInfo("Transform data to Bitmap...");
#endif
    switch(DataWnd->eOutputType)
    {
    case ReciprokeLatticeBitmap:
        GenerateRLBitmap();
        break;

    case MatrixBitmap:
        GenerateAngleSpaceBitmap();
        break;
    }
};

//! Zwischenablageoperation, wenn Typ CF_DIB
HGLOBAL TBitmapSource::RenderDIB(void)
{
    HGLOBAL hMem;
    long szInfo;
    HPBYTE hpNewData;
    HPBYTE hpData;
    LPBITMAPINFO lpBMPInfo;

    lpBMPInfo = (LPBITMAPINFO) GlobalLock(hDIBInfo);
    if(hDIBData && lpBMPInfo)
    {
        szInfo = sizeof(BITMAPINFO)
                 +(lpBMPInfo->bmiHeader.biClrUsed-1) * sizeof(RGBQUAD);
        hMem = GlobalAlloc(GMEM_MOVEABLE,szInfo+GlobalSize(hDIBData));
        if(hMem)
        {
            hpNewData = (HPBYTE)GlobalLock(hMem);
            memcpy(hpNewData,lpBMPInfo,(int)szInfo);
            hpData = (HPBYTE) GlobalLock(hDIBData);
            // move bitmap bits
#ifdef __WIN32__
            memcpy(hpNewData+szInfo,hpData,GlobalSize(hDIBData));
#else
            hmemcpy(hpNewData+szInfo,hpData,GlobalSize(hDIBData));
#endif
            GlobalUnlock(hDIBData);
            GlobalUnlock(hMem);
            GlobalUnlock(hDIBInfo);
        }
        return hMem;
    }
    else
        return NULL;
};

//! was soll dass???
void TBitmapSource::UpdateBitmapSource(void)
{}
;

//******************************************************************************
//********** Klasse PlotData *****************************
//******************************************************************************
//! Konstruktor TPlotData
TPlotData::TPlotData() : TMDIWindow()
{
	 //! Font - Def. in windows.h
	 LOGFONT lf;
	 //! durch einen Aufruf von set_new_handler(0) wird das traditionelle
	 //! new-Verhalten wiederhergestellt, bei dem keine Exception ausgeloest wird
	 set_new_handler(0);
	 //! CoorSys - Typ TCoorSystem
	 //! xST/yST/zST darin als TScaleType (comhead.h) def.
	 CoorSys.xST = Linear;
	 CoorSys.yST = Logarithmic;
	 CoorSys.zST = Linear;
	 //! eOutputType - Typ TOutputType (m_data.h)
	 eOutputType = Curve;
	 //! bXY_Scaling - Typ Bool (m_data.h)
	 bXY_Scaling = FALSE;
	 //! bButtonDown - Typ Bool (m_data.h)
	 bButtonDown = FALSE;
	 //! LowerBound,UpperBound - Typ float (m_data.h)
	 LowerBound = 1e-1; //! gibt beim ersten Aufruf MinIntensitaet vor
	 UpperBound = 1e5; //! gibt beim ersten Aufruf MaxIntensitaet vor

	 //! bSecondaryCoor - Typ Bool (m_data.h)
	 bSecondaryCoor = FALSE;
	 //! Def. am Anfang von M_data.cpp - static BOOL bAltCoorSystem = FALSE
	 bAltCoorSystem = FALSE;

	 //! gibt vor, das bein Init. kein BSource existiert
	 bBitmapIsCreated = FALSE;

	 //! Screen - Typ TScreen (m_data.h)
	 Screen.x0 = 0;
	 Screen.x1 = stdx-1;
	 Screen.dx = stdx;
	 Screen.y0 = 0;
	 Screen.y1 = stdy-1;
	 Screen.dy = stdy;
	 //! SecondCurve - Typ TCurve (m_curve.h)
	 SecondCurve = (TCurve *) new TCurve(200);
	 //! BSource - Zeiger auf Objekt vom Typ TBitmapSource (m_data.h)
	 BSource = NULL;
	 //! memset (mem.h) setzt die ersten sizeof(LOGFONT) Bytes des Array lf
	 //! auf den Wert von 0; LogFont spezifizieren...
	 memset(&lf,0,sizeof(LOGFONT));
	 lf.lfHeight = -13;
	 lf.lfWidth = 0; // wird automatisch entsprechend der Hoehe gesetzt
	 lf.lfWeight = 400;
	 lf.lfUnderline = FALSE;
	 lstrcpy(lf.lfFaceName,"Times New Roman");
	 //! the CreateFontIndirect function creates a logical font that has
	 //! the characteristics specified in the specified structure
	 hFont = CreateFontIndirect(&lf);
	 //! wenn ReciprokeLatticeBitmap oder MatrixBitmap dann generiere
	 //! neues Objekt vom Typ TBitmapSource und rufe
	 //! Fkt. FormatDBaseToBitmapSource
	 if(eOutputType <= MatrixBitmap) // notify type TOutputType
	 {
		  new TBitmapSource(this);
		  BSource->FormatDBaseToBitmapSource();
	 }
	 else
		  //! setze neue Koordinatensystembereiche
		  SetRanges();
	 //! CoorSys wird in AltCoorSys gesichert
	 AltCoorSys = CoorSys;
	 //! setze Bool-Variable bEnablePaint auf TRUE (m_data.h)
	 EnablePaint();
	 //! noch keine alten Daten geladen...
	 SetFileType(0);
#ifdef GermanVersion
	 strcpy(abzisse,"Scanachse ???");
#else
	 strcpy(abzisse,"Scanaxis ???");
#endif
};

//! Destruktor TPlotData
TPlotData::~TPlotData()
{
    //! loesche SecondCurve - Typ TCurve (m_curve.h)
    delete SecondCurve;
    //! wenn ReciprokeLatticeBitmap oder MatrixBitmap dann loesche
    //! BSource - Typ TBitmapSource (m_data.h)
    if(bBitmapIsCreated) delete BSource;
    retval = DeleteObject(hFont);
};

BOOL TPlotData::New(void)
{
    //! wenn ReciprokeLatticeBitmap oder MatrixBitmap dann generiere
    //! gleich auch neue BSource - Typ TBitmapSource (m_data.h)
    if(eOutputType <= MatrixBitmap)
		  BSource->New();
	 //! liefert Zeiger auf ein neues TMDIWindow zurueck
	 return TMDIWindow::New();
}

//! berechnet neue Groesse fuer Ausgabefenster, wenn mit Mouse geaendert
//! keine Groessenanpassung mehr vorgesehen...
/* Fehler 12
void TPlotData::Size(HWND hWnd,WPARAM,LPARAM)
//! berechne Groee des Screens
{
//! the GetClientRect function retrieves the coordinates
//! of a window's client area
//! hWnd - handle of window; &WndRect - address of Rect structure for
//! client coordinates
 GetClientRect(hWnd,&WndRect);
//! nicht hBitmap (Bitmap-windows.h) und
//! ReciprokeLatticeBitmap oder MatrixBitmap
 if(!::hBitmap && (eOutputType <= MatrixBitmap))
 {
//! berechne Groee des Screens und setze Struct-Variablen
//! woher kommen ominoese Multiplikatoren fuer dx und dy ???
 Screen.dx = (WndRect.right - WndRect.left) - xBorder;
 Screen.x0 = 0;
 Screen.x1 = Screen.dx;
 Screen.dx *= 0.8;
 Screen.dy = (WndRect.bottom - WndRect.top) - yBorder;
 Screen.y0 = 0;
 Screen.y1 = Screen.dy;
 Screen.dy *= 0.9;
 }
};
*/

//! setze neue Koordinatensystembereiche
void TPlotData::SetRanges()
{
	 CoorSys.xMin = 0.01;
	 CoorSys.xMax = 100.0;
	 //! nur RecipokeLatticeBitmap und MatrixBitmap haben x,y,z Koordinatensystem
	 if(eOutputType <= MatrixBitmap)
	 {
		  CoorSys.yMin = 0.01;
		  CoorSys.yMax = 100.0;
		  CoorSys.zMax = UpperBound;
		  CoorSys.zMin = LowerBound;
	 }
	 else
	 {
		  CoorSys.xMin = 0.01;
		  CoorSys.xMax = 100.0;
		  CoorSys.yMax = UpperBound;
		  CoorSys.yMin = LowerBound;
	 }
};

//! behandelt Kommando: linke Maustaste wurde gedrueckt
//! gibt x und y Werte in der untersten Statuszeile aus, wenn linke
//! Maustaste kurzzeitig gedrueckt, in einem Koord.system
void TPlotData::lButtonDown(WPARAM,LPARAM lParam)
{
	 char buf[MaxString];
	 int xi,yi,temp1,temp2,temp3;
	 TCoorSystem* pCoorSys;

	 LPCurve ScanReport;
	 float x,y,z,offset,temp_xo,ODelta,TDelta;
	 double Omega,Theta;
	 int row,column;
	 TCurve* Scan;

	 //! the GetDC function retrieves a handle of a display device context (DC)
	 //! for the client area of the specified window
	 //! DragDC - Typ HDC (m_data.h) - Handle auf ein DC (dc.h)
	 DragDC = GetDC(hWndChild);
	 bButtonDown = TRUE;
	 //! setzt den Mausfang auf das aktuelle Fenster
	 SetCapture(hWndChild);
	 //! switch Anweisung folgt dem, wohin, mit der Maus geklickt wurde
	 //! bzw welche Optionen an waren...
	 switch(eOutputType)
	 {
	 case ReciprokeLatticeBitmap:
	 case MatrixBitmap:
		  xi = LOWORD(lParam) - xBorder;
		  yi = Screen.y1 - HIWORD(lParam) - yBorder;
		  pCoorSys = &AltCoorSys;
		  break;

	 default:
		  xi = LOWORD(lParam) - xBorder;
		  yi = Screen.y1 - HIWORD(lParam);
		  pCoorSys = &CoorSys;
	 }
	 switch(pCoorSys->xST)
	 {
	 case Logarithmic:
		  break;
	 case Linear:
		  xo = ((float)xi * pCoorSys->xSF) + pCoorSys->xMin;
		  break;
	 }
	 switch(pCoorSys->yST)
	 {
	 case Logarithmic:
		  y = yi * pCoorSys->ySF;
		  if(y > 7.0)
				y = yi * log10(pCoorSys->yMax / pCoorSys->yMin) / Screen.dx;
		  yo = pow(10,y) * pCoorSys->yMin;
		  break;
	 case Linear:
		  yo = (yi * pCoorSys->ySF) + pCoorSys->yMin;
		  break;
	 }

	 ScanReport = lpDBase->GetScanReport();


	 //! ThetaOffset muss in Koordinatenausgabe beruecksichtigt werden
	 if(eOutputType==MatrixBitmap)
	 {
		  row = ScanReport->GetValueByValue(yo,x,y);
		  offset=GetThetaOffset(row)-VisualDB.dThetaMinFirst;
		  temp_xo=xo;

		  if(VisualDB.bPsd)
		  {
			  xo=xo-pCoorSys->xMin;
			  xo=xo-offset;
		  }
	 }
	 else temp_xo=xo;

//!	 switch(nMouseAction)
//!	 {
		  //! void TAreaScan::lButtonDown(WPARAM wParam,LPARAM lParam)
		  //! in m_arscan.cpp --- if(bAquisitionActive) nMouseAction=100
		  //! Wert 0 oder 100(wenn DataAquisition aktiv)
//!	 case 100:
		  //! wenn DataAquisition aktiv
//!		  PointX[0] = temp_xo;
//!		  PointY[0] = yo;
//!		  break;
//!	 default:
		  PointX[0] = temp_xo;
		  PointY[0] = yo;

		  //! zeige X,Y,Intensitaet,Row,Column in Statuszeile
		  //! - wenn in Koordinatensystem geklickt
		  if (yo<=pCoorSys->yMax && yo>=pCoorSys->yMin &&
					 temp_xo<=pCoorSys->xMax && temp_xo>=pCoorSys->xMin)
		  {
				switch(eOutputType)
				{
				case MatrixBitmap:
					 Omega = yo;
					 Theta = xo;
					 //! Zeile und Spalte in der Areascan-Datenbasis holen und Pointer darauf setzen
					 row = ScanReport->GetValueByValue(Omega,ODelta,y);
					 Scan = lpDBase->GetCurve(row);
					 //** pick out the intensity
					 column = Scan->GetValueByValue(Theta,TDelta,y);
					 Scan->SetPP(column);
					 //! Intensitaet holen
					 Scan->FastPGet(x,y,z);

					 xo=temp_xo;
					 break;


				case ReciprokeLatticeBitmap:

					 //! Zeile und Spalte im Bitmap berechnen
					 row=(yo-pCoorSys->yMin)/pCoorSys->ySF;
					 column=(xo-pCoorSys->xMin)/pCoorSys->xSF;
					 //! Omega und Theta aus dem "Daten"Feld holen
					 if (BSource->dateniscreated)
					 {
						  Omega=BSource->daten[row][column].omega;
						  Theta=BSource->daten[row][column].theta;
					 }
					else
					 {
						  Omega=0;
						  Theta=0;
					 }

					 //! nur die Vorinitialisierung des "Daten"feldes abfangen
					 if ((Omega && Theta)==row*row-column*column)
					 {
						  Omega=Theta=row=column=0;
					 }
					 else
					 {
						  //! Zeile und Spalte in der Areascan-Datenbasis holen und Pointer darauf setzen
						  row = ScanReport->GetValueByValue(Omega,x,y);
						  Scan = lpDBase->GetCurve(row);
						  //** pick out the intensity
						  column = Scan->GetValueByValue(Theta,x,y);
						  Scan->SetPP(column);
						  //! Intensitaet holen
						  Scan->FastPGet(x,y,z);
						  //! zur Ausgabe in der Statuszeile Thetaoffset aufaddieren
//! diese Unterscheidung, da 0-dim. andere Datenbasisspeicherung als
//! 1-dim Areascans (ThetaOffset mitgespeichert/nichtgespeichert)
						  if (VisualDB.bPsd) Theta = Theta + GetThetaOffset(row);
					 }
					 break;
				}
				//! hier Unterscheidung nach benoetigter Genauigkeit eingebaut - Fehler 6
				temp1=GetNachkommaStelle(pCoorSys,1,0);
				temp2=GetNachkommaStelle(pCoorSys,0,1);


				//! dies defaultmaessig in Statuszeile ausgeben...
				sprintf(buf,"X: %.*f Y: %.*f",temp1,temp_xo,temp2,yo);

				if (y>=1000) temp3=0;
					else if (y>=100) temp3=1;
						else if (y>=10) temp3=2;
							else temp3=3;

				if (row && column)
				{
					 switch (eOutputType)
					 {
					 case MatrixBitmap:
#ifdef GermanVersion
						  sprintf(buf,"Theta:%.*f (D:%.3f) Omega:%.*f (D:%.3f) Int.:%.*f Zeile:%d Spalte:%d"
									 ,temp1,xo,TDelta,temp2,yo,ODelta,temp3,y,row,column);
#else
						  sprintf(buf,"Theta:%.*f (D:%.3f) Omega:%.*f (D:%.3f) Int.:%.*f Row:%d Column:%d"
						  ,temp1,xo,TDelta,temp2,yo,ODelta,temp3,y,row,column);
#endif
						  break;

					 case ReciprokeLatticeBitmap:
#ifdef GermanVersion
						  sprintf(buf,
									 "X:%.*f Y:%.*f Theta:%.3f Omega:%.3f Int.:%.*f Zeile:%d Spalte:%d"
									 ,temp1,xo,temp2,yo,Theta,Omega,temp3,y,row,column);
#else
						  sprintf(buf,
									 "X:%.*f Y:%.*f Theta:%.3f Omega:%.3f Int.:%.*f Row:%d Column:%d"
									 ,temp1,xo,temp2,yo,Theta,Omega,temp3,y,row,column);
#endif
						  break;
					 }
				}

				//! Def. SetInfo(buf) in evrythng.h
				//! sendet Nachricht an Window, um Statuszeile zu aendern
				SetInfo(buf);

		  }//! Ende if
#ifdef GermanVersion
		  else SetInfo("ausserhalb des Bereichs");
#else
		  else SetInfo("out of Range");
#endif
//!	 } //! Ende switch(nMouseAction)
}
;

void TPlotData::MouseMove(WPARAM,LPARAM lParam)
//! diese Fkt. gibt in der Statuszeile dx und dy Werte aus
//! wenn mit gedrueckter linker Maustaste ueber ein Koord.system gefahren wird
{
	 char buf[MaxString];
	 int xi,yi,temp1,temp2;
	 float x,y;
	 TCoorSystem* pCoorSys;

	 //! wenn Button nicht gedrueckt gehe zurueck...
	 if(!bButtonDown) return;

	 switch(eOutputType)
	 {
	 case ReciprokeLatticeBitmap:
	 case MatrixBitmap:
		  xi = LOWORD(lParam) - xBorder;
		  yi = Screen.y1 - HIWORD(lParam) - yBorder;
		  pCoorSys = &AltCoorSys;
		  break;

	 default:
		  xi = LOWORD(lParam) - xBorder;
		  yi = Screen.y1 - HIWORD(lParam);
		  pCoorSys = &CoorSys;
	 }
	 //! Abziss immer linear skaliert
	 x = (xi * pCoorSys->xSF) + pCoorSys->xMin;
	 //! Ordinate linear oder log skaliert
	 switch(pCoorSys->yST)
	 {
	 case Logarithmic:
		  y = yi * pCoorSys->ySF;
		  if(y > 7.0)
				y = yi * log10(pCoorSys->yMax / pCoorSys->yMin) / Screen.dx;
		  y = pow(10,y) * pCoorSys->yMin;
		  break;
	 case Linear:
		  y = (yi * pCoorSys->ySF) + pCoorSys->yMin;
		  break;
	 }
	 //! zeige dX,dY in Statuszeile - wenn in Koordinatensystem geklickt
	 if (PointY[0]<=pCoorSys->yMax && PointY[0]>=pCoorSys->yMin
				&& PointX[0]<=pCoorSys->xMax && PointX[0]>=pCoorSys->xMin
				&& y<=pCoorSys->yMax && y>=pCoorSys->yMin
				&& x<=pCoorSys->xMax && x>=pCoorSys->xMin)
	 {
		  switch(nMouseAction)
				//! void TAreaScan::lButtonDown(WPARAM wParam,LPARAM lParam)
				//! in m_arscan.cpp --- if(bAquisitionActive) nMouseAction=100
		  {
		  case 100:
				//! wenn DataAquisition aktiv
				PointX[1] = x;
				PointY[1] = y;
				temp1=GetNachkommaStelle(pCoorSys,1,0);
				temp2=GetNachkommaStelle(pCoorSys,0,1);
#ifdef GermanVersion
				sprintf(buf,"Linie von (%.*f, %.*f) bis (%.*f, %.*f)",
						  temp1,PointX[0],temp2,PointY[0],temp1,PointX[1],temp2,PointY[1]);
#else
				sprintf(buf,"Line from (%.*f, %.*f) to (%.*f, %.*f)",
						  temp1,PointX[0],temp2,PointY[0],temp1,PointX[1],temp2,PointY[1]);
#endif
				break;

		  default:
				//! hier Unterscheidung nach benoetigter Genauigkeit eingebaut - Fehler 6
				temp1=GetNachkommaStelle(pCoorSys,1,0);
				temp2=GetNachkommaStelle(pCoorSys,0,1);
				sprintf(buf,"dX = %.*f dY = %.*f",temp1,x-xo,temp2,y-yo);
		  }
		  //! Def. SetInfo(buf) in evrythng.h
		  //! sendet Nachricht an Window, um Statuszeile zu aendern
		  SetInfo(buf);
	 }
#ifdef GermanVersion
	 else	SetInfo("ausserhalb des Bereichs");
#else
	 else SetInfo("out of Range");
#endif
};

void TPlotData::lButtonUp(WPARAM,LPARAM)
//! nur dazu da, um das Loslassen der linken Maustaste zu registrieren
{
	 bButtonDown = FALSE;
	 ReleaseDC(hWndChild,DragDC);
	 ReleaseCapture();
};

//! fuelle TKSystem mit Standardwerten
BOOL TPlotData::SetMeasurementArea(TKSystem &ks)
{
	 ks[0].x = 1.0;
	 ks[0].y = 1.0;
	 ks[0].Ord = 0;
	 ks[1].x = 10.0;
	 ks[1].y = 1.0;
	 ks[1].Ord = 1;
	 ks[2].x = 10.0;
	 ks[2].y = 10.0;
	 ks[2].Ord = 2;
	 ks[3].x = 1.0;
	 ks[3].y = 10.0;
	 ks[3].Ord = 3;
	 return TRUE;
};

void TPlotData::RenderFormat(WPARAM wParam)
//! the WM_RENDERFORMAT message is sent to the clipboard owner
//! when a particular format with delayed rendering needs to be rendered
//! HANDLE SetClipboardData(uint format, HANDLE handle);
//! bei erfolgreicher Ausfuehrung ist der Rueckgabewert ein Handle auf die Daten
{
    HANDLE hClip;

    if(eOutputType > MatrixBitmap) return;
    switch(wParam)
    {
    case CF_BITMAP:
        hClip = (HANDLE)BSource->CreateGDIObject(GetDC(hWndChild));
        SetClipboardData(CF_BITMAP,hClip);
        break;

	 case CF_PALETTE:
        hClip = (HANDLE)CreatePalette(BSource->GetPalette());
        SetClipboardData(CF_PALETTE,hClip);
        break;

    case CF_DIB:
        hClip = BSource->RenderDIB();
        SetClipboardData(CF_DIB,hClip);
        break;
    }
};

void TPlotData::RenderAllFormats(WPARAM)
//! the WM_RENDERALLFORMATS message is sent to the clipboard owner
//! when the owner application is being destroyed
{
    UINT uFormat=0;

    OpenClipboard(hWndChild);
    // hier stand ein =, was soll das?
    while(NULL != (uFormat = EnumClipboardFormats(uFormat)))
        SendMessage(hWndChild,WM_RENDERFORMAT,uFormat,0L);
    CloseClipboard();
};

void TPlotData::DoCopy(void)
//! Kopieren mit Hilfe der Zwischeablage - Typen: CF_DIB, CF_PALETTE

{
    //! OpenClipboard(hWnd) - oeffnet die Zwischenablage und hindert
    //! andere Anwendungen daran, den Inhalt der Zwischenablage zu veraendern
    //! (Ausgabetyp ist nicht Matrix- oder RL Bitmap) oder Zwischenablage
	 //! geht nicht auf ---> denn zurueck...
    if((eOutputType > MatrixBitmap) || !OpenClipboard(hWndChild)) return;

    //! EmptyClipBoard() - Leert die Zwischenablage
    //! und gibt alle Handles auf die Daten der Zwischenablage frei
    EmptyClipboard();

    //! SetClipBoardData(...) - setzt ein Handle auf den Datenblock
    //! an der durch handle angezeigten Position
    SetClipboardData(CF_DIB,NULL);
    SetClipboardData(CF_PALETTE,NULL);

    //! schliet die Zwischenablage
    CloseClipboard();
};

void TPlotData::DrawCoordinateSystem(HDC hdc)
//! zeichnet Koord.System - oder was soll der Name sonst :-)
{
    //! der Datentyp, der das Handle auf eine physikalische Schrift repraesentiert
    HFONT hOldFont;
    //! der Windows-Datentyp, der Handles fuer logische Stifte repraesentiert
	 HPEN hOldPen,hPenDot,hPenBlack;
    //! TCoorSystem - m_data.h
	 TCoorSystem* pCoorSys;
    //! the SIZE structure specifies the width and height of a rectangle
    SIZE tagS;
	 //! the POINT structure defines the x- and y- coordinates of a point
    POINT egde[5];
    char buf[40];
	 float fval,fval1,offset,xMin,xMax,xSF;
    int i,temp1;

    hPenBlack = CreatePen(PS_SOLID,2,RGB(0,0,0));
    hPenDot = CreatePen(PS_DOT,1,RGB(0,0,0));
    hOldFont = (HFONT)SelectObject(hdc,hFont);
    hOldPen = (HPEN)SelectObject(hdc,hPenBlack);
    // Rahmen zeichnen
    egde[0].x = egde[3].x = Screen.x0;
    egde[1].x = egde[2].x = Screen.x0 + Screen.dx;
    egde[0].y = egde[1].y = Screen.y0;
    egde[2].y = egde[3].y = Screen.y0 + Screen.dy;
    egde[4] = egde[0];
    Polyline(hdc,egde,5);

    //************ Absizze (x) *************************************************
    gdiobj = SelectObject(hdc,hPenBlack);
    switch(eOutputType)
	 {
	 case Curve:
        pCoorSys = &CoorSys;

        break;
    case MatrixBitmap:
		  pCoorSys = &AltCoorSys;
        break;

    case ReciprokeLatticeBitmap:
        pCoorSys = &AltCoorSys;
        break;
    }

    gdiobj = SelectObject(hdc,hPenDot);

    //! dient zur Unterscheidung, um ThetaOffset in RawMatrix bei
    //! Winkeldarstellung zu beruecksichtigen
    if (eOutputType==MatrixBitmap && bSecondaryCoor)
    {
        offset=VisualDB.dThetaMinLast-VisualDB.dThetaMinFirst;//GetThetaOffset(lpDBase->GetCNumber()-1)-GetThetaOffset(0);
        offset=offset/pCoorSys->xSF;
        i=0;
    }
	 else
    {
        offset=0;
        i=1;
	 }

    for(i;i < tilesx;i++)
    {
        //! zeichnet Verbindungslinien ein...
		  egde[0].x = i / tilesx * (Screen.dx) + Screen.x0;
        egde[1].x = i / tilesx * (Screen.dx) + Screen.x0 + offset;
        egde[0].y = Screen.y0;
        egde[1].y = Screen.y0 + Screen.dy;

        //! falls Hilfslinien ausserhalb des Screens fallen, berechne Anstieg der Geraden
        //! und zugehoerigen y-Wert
        if (egde[1].x>Screen.dx+Screen.x0)
        {
				egde[1].x=Screen.dx+Screen.x0;
				egde[1].y=(Screen.dx+Screen.x0-egde[0].x)*((Screen.dy-Screen.y0)/offset);
		  }
		  Polyline(hdc,egde,2);
	 }

	 //! eingefuegt fuer dtn-File Abzissenbeschriftung
	 if (eLoadFormat==dtnFile)
		  pCoorSys->zSF=(pCoorSys->zMax-pCoorSys->zMin)/Screen.dx;

	 //! zeichnet die Markierungen an der x-Achse
	 for(i = 0;i <= tilesx;i++)
	 {
		  fval = i / tilesx * Screen.dx;
		  egde[0].x = egde[1].x = Screen.x0 + fval + offset;
		  egde[0].y = Screen.y0 + Screen.dy;
		  egde[1].y = Screen.y0 + Screen.dy - 5;
		  if (egde[1].x<Screen.dx+Screen.x0) Polyline(hdc,egde,2);
		  egde[0].x = egde[1].x = Screen.x0 + fval;
		  egde[0].y = Screen.y0 + 5;
		  egde[1].y = Screen.y0;
		  Polyline(hdc,egde,2);

		  //! eingefuegt fuer dtn-File Abzissenbeschriftung
		  if (eLoadFormat==dtnFile) fval1=pCoorSys->zMin + fval * pCoorSys->zSF;

		  if (eOutputType==MatrixBitmap && bSecondaryCoor)
		  {
				xMin = MainCurve->Min[ P_Z ];
				xMax = (MainCurve->Max[ P_Z ]*pCoorSys->xMax)/(MainCurve->Max[ P_X ] + GetThetaOffset(0));
				xSF = (xMax - xMin)/Screen.dx;
				fval=xMin + fval * xSF;
				sprintf(buf,"%.0f",fval);
		  }
		  else if (bSecondaryCoor) //! im Falle von Curve und Kanalbeschriftung
		  {
			  fval=pCoorSys->xMin + fval * pCoorSys->xSF;
			  sprintf(buf,"%.0f",fval);
		  }
		  else //! im Falle von Winkelbeschriftung
		  {
				fval=pCoorSys->xMin + fval * pCoorSys->xSF;
				temp1=GetNachkommaStelle(pCoorSys,1,0);
				sprintf(buf,"%.*f",temp1,fval);
		  }

		  if(WindowType==W_PSDWindow && i==tilesx)
		  {
			  if (eOutputType==ReciprokeLatticeBitmap) sprintf(buf,"qx");
           else sprintf(buf,"Theta");

		  }
//! ACHTUNG HIER ABZISSENBESCHRIFTUNG BEI LINESCAN!!!
		  else if (i==tilesx && WindowType==W_DiffractionWindow && eLoadFormat!=dtnFile) sprintf(buf,abzisse);
		  else if (i==tilesx && eLoadFormat!=dtnFile) sprintf(buf,"");

		  GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
		  tagS.cx /= 2;
		  if (i==tilesx) egde[0].x = egde[0].x-tagS.cx-1;
		  // tagS.cy /= 2;
		  //! schreibt die Einheiten an die x-Achse
		  //! Unterscheidung eingfuegt, damit ein dtnFile andere Abzissenbeschriftung hat
		  if (eLoadFormat!=dtnFile) TextOut(hdc,egde[0].x - tagS.cx,tagS.cy - yBorder / 2 - 15*(i%2),buf,strlen(buf));
		  else
		  {
				TextOut(hdc,egde[0].x - tagS.cx,tagS.cy - yBorder / 2,buf,strlen(buf));
				sprintf(buf,"%.*f",temp1,fval1);
				TextOut(hdc,egde[0].x - tagS.cx,tagS.cy - yBorder / 2 -15 ,buf,strlen(buf));
		  }
	 }
	 //************ Ordinate (y) **************************************************
	 switch(eOutputType)
	 {
	 case Curve:
	 case ReciprokeLatticeBitmap:
	 case MatrixBitmap:
		  //! the SelectObject function selects an object into the specified
		  //! device context (DC)
		  gdiobj = SelectObject(hdc,hPenDot);
		  for(i = 1;i < tilesy;i++)
		  {
				//! zeichnet Verbindungslinien ein...
				egde[0].y = egde[1].y = 1 + i / tilesy * Screen.dy + Screen.y0;
				egde[0].x = Screen.x0;
				egde[1].x = Screen.x0 + Screen.dx;
				Polyline(hdc,egde,2);
		  }
		  break;
	 }

	 gdiobj = SelectObject(hdc,hPenBlack);

	 for(i = 0;i <= tilesy;i++)
	 {
		  //! zeichnet Markierungen an den y-Achsen
		  fval1 = i / tilesy * Screen.dy;
		  egde[0].y = egde[1].y = Screen.x0 + fval1;
		  egde[0].x = Screen.x0 + Screen.dx;
		  egde[1].x = Screen.x0 + Screen.dx - 5;
		  Polyline(hdc,egde,2);
		  egde[0].x = Screen.x0 + 5;
		  egde[1].x = Screen.x0;
		  Polyline(hdc,egde,2);
		  switch(pCoorSys->yST)
		  {
		  case Linear:
				fval1 = pCoorSys->yMin + fval1 * pCoorSys->ySF;
				break;
		  default:
				fval1 = pCoorSys->yMin * pow(10,fval1 * pCoorSys->ySF);
		  }

		  //! schreibt in buf den entsprechenden Wert fuer Achsenbeschriftung
		  if (fval1==0) sprintf(buf,"0.00");
		  else
		  {
				temp1=GetNachkommaStelle(pCoorSys,0,1);
				sprintf(buf,"%.*f",temp1,fval1);
		  }

		  if (i==tilesy && eOutputType==Curve)
			  switch(pCoorSys->yST)
			  {
				  case Linear:
#ifdef GermanVersion
					  sprintf(buf,"linear skaliert");
#else
					  sprintf(buf,"linear scaling");
#endif
					  break;
				  case Logarithmic:
#ifdef GermanVersion
					  sprintf(buf,"log10 skaliert");
#else
					  sprintf(buf,"log10 scaling");
#endif
					  break;
				  }
				  else if (i==tilesy && eOutputType!=Curve) sprintf(buf,"");

		  if(WindowType==W_PSDWindow && i==tilesy)
		  {
			  if (eOutputType==MatrixBitmap) sprintf(buf,"Omega");
			  else if (eOutputType==ReciprokeLatticeBitmap) sprintf(buf,"qz");
		  }
		  else if (i==tilesy && eOutputType!=Curve) sprintf(buf,"");

		  //! ermittelt die Groee des Textes der Einheiten an der y-Achse und
		  //! schreibt die Einheiten auf den Bildschirm
		  SetTextAlign(hdc,TA_LEFT);
		  GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
		  tagS.cx /= 2;
		  tagS.cy /= 2;
		  if (i!=tilesy) egde[0].y += tagS.cy;
		  egde[0].x = -(tagS.cx + xBorder * 0.5);
		  TextOut(hdc,egde[0].x,egde[0].y,(LPSTR)buf,strlen(buf));
	 }
	 //****************************************************************************
	 //! loesche hPenBlack,hPenDot und krame hOldPen, hOldFont wieder hervor
	 gdiobj = SelectObject(hdc,hOldPen);
	 retval = DeleteObject(hPenBlack);
	 retval = DeleteObject(hPenDot);
	 gdiobj = SelectObject(hdc,hOldFont);
};

int TPlotData::GetNachkommaStelle(TCoorSystem* pCoorSys,int x,int y)
//! neue Funktion, die die benoetigte Nachkommastellengenauigkeit
//! berechnet und die noetigen Nachkommastellen als int zurueckliefert
//! wenn x=1 dann fuer x-Achse / wenn y=1 dann fuer y-Achse
//! gehoert zu Fehler 6
{
	 float fval;

	 if (y) fval = fabs(pCoorSys->yMax - pCoorSys->yMin);
	 if (x) fval = fabs(pCoorSys->xMax - pCoorSys->xMin);

	 if(fval < 0.25)
        return 5;
    else
        if(fval < 1)
            return 4;
        else
            if(fval<3)
                return 3;
            else
                return 2;
};

//! Paint wird von EvPaint aufgerufen und automatisch von Windows angefordert,
//! um den Inhalt des Fensters neu anzuzeigen
//! Paint, das von Basisklassen aufgerufen wird, wenn diese auf eine WM_PAINT-
//! Botschaft reagieren
void TPlotData::Paint(HDC hdc,PAINTSTRUCT *)
{
    int cnt = 0;
    //! Windows-Datentyp, der Handles fuer logische Stifte repraesentiert
	 HPEN hOldPen,hPen;
    //! 32 bit Zeiger
    //! the POINT structure defines the x- and y-coordinates of a point
    LPPOINT lpPoints;
    //! the SIZE structure specifies the width and height of a rectangle
    SIZE tagS;
	 POINT tagP;
    //! The RECT structure defines the coordinates of the
    //! upper left and lower right corners of a rectangle
    RECT rect;

    //! EnablePaint(); setzt Bool-Variable bEnablePaint des Tplotdataobjektes
    //! auf TRUE - dies geschieht z.B. im Konstruktor
    if(!bEnablePaint) return;
    switch(eOutputType)
    {
        //! dies und viele folgende Sachen nur im Falle von Kurve zu tun...
    case Curve:
        if(bAltCoorSystem)
        {
            CoorSys = AltCoorSys;
            bAltCoorSystem = FALSE;
        }
        else
            //! setze neue Koordinatensystembereiche
            SetRanges();
        // Bestimmen der Ausdehnung in Pixeln des Zeichen-Fensters
		  GetClientRect(hWndChild,(LPRECT)&rect);
        // Daten-Bereich festlegen
        Screen.dx = (rect.right - rect.left) - xBorder;
        Screen.x0 = 0;
        Screen.x1 = Screen.dx;
        Screen.dy = (rect.bottom - rect.top) - yBorder;
        Screen.y0 = 0;
        Screen.y1 = Screen.dy;
        //! the SetMapMode function sets the mapping mode of the
        //! specified device context (DC)
        SetMapMode(hdc,MM_ANISOTROPIC);
        //! The SetWindowExtEx function sets the horizontal and vertical extents
        //! of the window for a device context by using the specified values
        SetWindowExtEx(hdc,Screen.dx + xBorder,Screen.dy + yBorder,&tagS);
        //! The SetViewportExtEx function sets the horizontal and vertical
        //! extents of the viewport for a device context by using the specified values
        SetViewportExtEx(hdc,Screen.dx + xBorder,-(Screen.dy + yBorder),&tagS);
        //! The SetWindowOrgEx function sets the window origin of
        //! the device context by using the specified coordinates
        SetWindowOrgEx(hdc,0,0,&tagP);
        //! The SetViewportOrgEx function sets the viewport origin
        //! of a device context by using the specified coordinates
        SetViewportOrgEx(hdc,xBorder,Screen.dy,&tagP);
        // inquire scaling parameters
        CoorSys.xSF = (CoorSys.xMax - CoorSys.xMin) / Screen.dx;
        switch(CoorSys.yST)
        {
		  case Linear:
            CoorSys.ySF = (CoorSys.yMax-CoorSys.yMin) / Screen.dy;
            break;
        default:
            CoorSys.ySF = log10(CoorSys.yMax/CoorSys.yMin) / Screen.dy;
        }
        //! Def. WholeWnd() in main.cpp
        //! Returnwert von WholeWnd()=TRUE, wenn Variable bPaintpoint des
        //! TMDIWindow=FALSE
        if(WholeWnd())
            DrawCoordinateSystem(hdc); // don't redraw coordinate system
        //! erst irgendwas mit der 2. Kurve machen und zeichnen, dann mit der 1. Kurve
        if(1 < SecondCurve->GetPNumber()) //! 1 < letzter Eintrag + 1
        {
            lpPoints = (LPPOINT)new POINT [SecondCurve->GetPNumber()];
            //! setzt ActualIdx auf pos oder auf MaxPointIdx, wenn pos>MaxPointidx
            //! hier ActualIdx=0
            SecondCurve->SetPP(0);
            //! fuellt die Struktur lpPoints mit den Werten fuer eine Kurve...
            FormatCurveToPLine(SecondCurve,lpPoints,cnt);
            //! ...um damit spaeter dann die Kurve darzustellen
            hPen = CreatePen(PS_SOLID,1,RGB(0,0,255));
            hOldPen = (HPEN)SelectObject(hdc,hPen);
            Polyline(hdc,lpPoints,cnt);
            gdiobj = SelectObject(hdc,hOldPen);
            retval = DeleteObject(hPen);
            delete[] lpPoints;
		  }
        if(1 < MainCurve->GetPNumber()) //! 1 < letzter Eintrag + 1
        {

            //! folgendes wird mit FastOpen aktualisiert (betrifft Klasse Curve...)
            //! BOOL* lpPV; // Zeiger auf Datenfeld von Validate
            MainCurve->FastOpen();

            //! Def. WholeWnd() in main.cpp
            //! Returnwert von WholeWnd()=TRUE, wenn Variable bPaintpoint des
            //! TMDIWindow=FALSE
            if(WholeWnd())
            {
                lpPoints = (LPPOINT)new POINT [MainCurve->GetPNumber()];

                //! letzter Eintrag + 1
                //! setzt ActualIdx auf pos oder auf MaxPointIdx, wenn pos>MaxPointidx
                //! hier ActualIdx=0
                MainCurve->SetPP(0);
            }
            else
            {
                lpPoints = (LPPOINT)new POINT [2];

                //! setzt ActualIdx auf 30000 oder auf MaxPointIdx, wenn 30000>MaxPointidx
                //! was aber wenn MaxPointIdx>30000, wird der ActualIdx auf 30000 beschraenkt???
                //! scheint eine ominoese 30000 zu sein???
					 MainCurve->SetPP(30000);

                //! bEnd = FALSE; if(ActualIdx > 0) --ActualIdx;
                MainCurve->BackStep();
            }
            //! fuellt die Struktur lpPoints mit den Werten fuer eine Kurve...
            FormatCurveToPLine(MainCurve,lpPoints,cnt);

            //! GlobalUnlock(hMemX);GlobalUnlock(hMemY);GlobalUnlock(hMemZ);
            //! GlobalUnlock(hMemV);bStreamOpen = FALSE; - Fkt. FastClose();
            MainCurve->FastClose();

            //! ...um damit spaeter dann die Kurve darzustellen
            hPen = CreatePen(PS_SOLID,1,RGB(255,0,0));
            hOldPen = (HPEN)SelectObject(hdc,hPen);
            Polyline(hdc,lpPoints,cnt);
            gdiobj = SelectObject(hdc,hOldPen);
            retval = DeleteObject(hPen);
            delete[] lpPoints;
        }
        break;

    case ReciprokeLatticeBitmap:
    case MatrixBitmap:

        //! Coorsys.ySF/Coorsys.xSF nochmal neu setzen, da ansonsten falsch
        //! Fehler 14
		  CoorSys.xSF = (CoorSys.xMax - CoorSys.xMin) / Screen.dx;
        CoorSys.ySF = (CoorSys.yMax - CoorSys.yMin) / Screen.dy;

        //! auskommentiert, weil Fkt. UpdateBitmapSource() nicht def.
        // if(!WholeWnd()) BSource->UpdateBitmapSource();
        //! the GetClientRect function retrieves the coordinates of
        //! a window's client area
        //! steht hier, wird aber nicht gebraucht???!
        //! GetClientRect(hWndChild,(LPRECT)&rect);

        //! bereitet den Screen vor
        BSource->SetScreen(hdc,Screen);

        //! the SetMapMode function sets the mapping mode of
        //! the specified device context (DC)
        SetMapMode(hdc,MM_TEXT);

        //! gibt die Bitmap aus
        BSource->DrawBitmap(hdc,0,-Screen.dy);


        BSource->SetScreen(hdc,Screen);
        //! fuellt struct ColorTable & ruft Fkt. DrawColorTable
        //! welche Intensitaeten und zugehoerige Farben berechnet
        //! und die Legende zu Intensitaetswerten zeichnet
        BSource->DrawBitmapFrame(hdc); // do this first
        DrawCoordinateSystem(hdc); // then execute this line
		  break;
    } // switch
    return;
};

void TPlotData::SetFileType(int type)
{
    eLoadFormat=type;
};

//! fuellt die Struktur lpPoints mit den Werten fuer eine Kurve
//! um damit spaeter dann die Kurve darzustellen
void TPlotData::FormatCurveToPLine(TCurve*crv,LPPOINT lpPoints,int &pcnt)
{
    float x1,x,y,z,xt,offset = GetThetaOffset(0);
    int idx = 0;

    // read first point
    if(bSecondaryCoor)
        //! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
        crv->FastPGet(z,y,x);
    else
    {
        //! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
        crv->FastPGet(x,y,z);
        x += offset;
    }
	 lpPoints[idx].x = (x - CoorSys.xMin) / CoorSys.xSF;
    switch(CoorSys.yST)
    {
    case Linear:
        //! dieses if eingefuegt, damit in diesem Fall die Pkt. nicht unterhalb der
        //! x-Achse fallen...
        if (y > CoorSys.yMin)
            lpPoints[idx].y = (y - CoorSys.yMin) / CoorSys.ySF;
        else
            lpPoints[idx].y = 0;
        break;
    default:
        if(y > CoorSys.yMin)
            lpPoints[idx].y = log10(y / CoorSys.yMin) / CoorSys.ySF;
        else
            lpPoints[idx].y = 0;
    }
    // read further points

    //! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
    for(idx = 1;crv->FastPGet(x1,y,xt);idx++)
    {
        if(!bSecondaryCoor)
        {
            xt = x1;
            xt += offset;
        }
		  if(fabs(xt-x) == 0.0) continue;
        lpPoints[idx].x = (xt - CoorSys.xMin) / CoorSys.xSF;
        if(lpPoints[idx-1].x == lpPoints[idx].x)
        {
            idx--;
            continue;
        }
        switch(CoorSys.yST)
        {
        case Linear:
            //! dieses if eingefuegt, damit in diesem Fall die Pkt. nicht unterhalb der
            //! x-Achse fallen... Fehler 5
            if (y > CoorSys.yMin)
                lpPoints[idx].y = (y - CoorSys.yMin) / CoorSys.ySF;
            else
                lpPoints[idx].y = 0;
            break;
        default:
            if(y > CoorSys.yMin)
                lpPoints[idx].y = log10(y / CoorSys.yMin) / CoorSys.ySF;
            else
                lpPoints[idx].y = 0;
        }
    }
    pcnt = idx;
};

//! sichert Koordinatensystem in AltCoorsys
//! m_main.cpp im Falle von cm_MoveScanReady
void TPlotData::SetKSProperties(TKSProperties* ksp)
{
    if(!ksp) return;
    AltCoorSys.yMin = ksp->fMinY;
    AltCoorSys.yMax = ksp->fMaxY;
    AltCoorSys.xMin = ksp->fMinX;
    AltCoorSys.xMax = ksp->fMaxX;
    if(ksp->bLogarithmicY)
        AltCoorSys.yST = Logarithmic;
    else
        AltCoorSys.yST = Linear;

    //! geaendert, weil xST meiner Meinung nach nie Logarithmic
    // AltCoorSys.xST = Logarithmic;
    AltCoorSys.xST = Linear;
    bAltCoorSystem = TRUE;
    UpdateWnd(0);
};

void TPlotData::PickUpData(LPARAM data)
//! wird nur in m_main.cpp im Falle von cm_MoveScanReady benoetigt
//! sichert Daten in der SecondCurve
{
    *SecondCurve = *((TCurve *)data);
};

//! wird aufgerufen aus dem Scan-Fenster-Menue unter Scan -> Loeschen
//! bei gesendetem cm_KillSecondCurve
//! setzt SecondCurve auf Initialwerte zur'ck (loeschen aller Messtripel)
//! zeichnet Scan-Fenster neu
void TPlotData::KillSecondCurve(void)
//! SecondCurve wird mit Standardwerten ueberschrieben
{
    SecondCurve->New();
    //! UpdateWnd(0) fuehrt ein Update des ClientWindows durch (Redraw)
    UpdateWnd(0);
};

//! wird aufgerufen aus dem Scan-Fenster-Menue unter Scan -> Fixieren
//! bei gesendetem Kommando cm_FreezeCurve
//! fixiert die aktuelle Hauptkurve -> setzt Pointer von SecondCurve auf MainCurve
void TPlotData::FreezeCurve(void)
//! speichert Objektzustand von MainCurve in SecondCurve
{
    if(1> MainCurve->GetPNumber())
      return ;
    *SecondCurve = *MainCurve;
};

//! wird aufgerufen aus dem Scan-Fenster-Men' unter Scan -> Speichern
//! bei gesendetem Kommando cm_SaveSecondCurve
//! speichert fixierte Kurve (SecondCurve) unter auszuwaehlendem Dateinamen
//! mit Extension *.bk
void TPlotData::SaveSecondCurve(void)
//! speichert die SecondCurve
{
	 char nfn[MAXPATH];
	 char Filter[MaxString];
	 OFSTRUCT of;
	 char msg[MaxString+1];
	 int hFile;
	 float x,y,z;
	 char buf[MaxString];

	 //! setzt Parameter f'r Win-API-Funktion 'FileSave', dazu gehoert Setzen
	 //! der Extension bzw. Filter und des Dialogbox-Titels + Aufruf der
	 //! Win-API-Funktion 'FileSave'
	 strcpy(nfn,"*.bk");
#ifdef GermanVersion
	 strcpy(Filter,"Vergleichs-Scan (*.bk)|*.bk||");
	 strcpy(msg,"Vergleichs-Scan speichern...");
#else
	 strcpy(Filter,"Comparison-Scan (*.bk)|*.bk||");
	 strcpy(msg,"Save Comparison-Scan...");
#endif
	 //! ruft eine Save As dialog box auf...
	 FileSave(msg,Filter,nfn,"");
	 //! Test, ob Dateiname ausgewaehlt und ob Datei Extension 'bk' hat, wenn
	 //! nicht Abbruch
	 if(nfn[0] == '*') return;
	 if(0 != strcmp(strupr(&(nfn[strlen(nfn)-2])),"BK")) return;
	 //! erstellen der Datei mit ausgewaehltem Namen + Test, ob dies moeglich
	 //! wenn nicht, Fehlermeldung + Abbruch
	 hFile = OpenFile(nfn,&of,OF_CREATE);
	 if(-1 == hFile)
	 {
		  LoadString(Main.hInstance,sth_CannotCreateFile,msg,MaxString);
		  MessageBox(GetFocus(),msg,"Fehler/Error",MB_OK | MB_ICONHAND);
		  return;
	 }
	 //! Wait-Mauszeiger setzen
	 ::hOldCursor = SetCursor(LoadCursor(NULL,IDC_WAIT));
#ifdef GermanVersion
	 strcpy(buf,"[Header]\nVergleichs-Scan \n");
#else
	 strcpy(buf,"[Header]\nComparison-Scan \n");
#endif
	 //! FileType mit eingefuehrt - TScan.eSaveFormat = bkFile (beim Einlesen)
	 strcat(buf,"FileType=Comparison\n");
	 strcat(buf,"X >> Intensity >> Z\n[Data]\n");
	 _lwrite(hFile,(LPSTR)buf,strlen(buf));

	 //! an Anfang der Kurve gehen + Speicher der Punkte fixieren
	 //! setzt ActualIdx auf 0 oder auf MaxPointIdx, wenn pos>MaxPointidx
	 //! hier ActualIdx=0
	 SecondCurve->SetPP(0);

	 //! folgendes wird mit FastOpen aktualisiert (betrifft Klasse Curve...)
	 //! BOOL* lpPV; // Zeiger auf Datenfeld von Validate
	 SecondCurve->FastOpen();

	 //! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
	 //! Kurve Tripel f'r Tripel auslesen und zeilenweise in der Datei ablegen
	 while(SecondCurve->FastPGet(x,y,z))
	 {   //! FIX Fehler 2 Diff/Refl
		  sprintf(buf,"%.3f %.3f %.3f",x,y,z);
		  strcat(buf, EOL);
		  _lwrite(hFile,(LPSTR)buf,strlen(buf));
	 }
	 //! Schlieen der Datei + Fixieren des Speichers der Kurve aufheben
	 //! Wait-Mauszeiger ausschalten
	 _lclose(hFile);
    //! GlobalUnlock(hMemX);GlobalUnlock(hMemY);GlobalUnlock(hMemZ);
    //! GlobalUnlock(hMemV);bStreamOpen = FALSE; - Fkt. FastClose();
    SecondCurve->FastClose();
    SetCursor(::hOldCursor);
    return;
};

//! neuer Modaldialog "User Skalierung"
#ifdef GermanVersion
TCurveFreeScal::TCurveFreeScal(TMDIWindow *pwnd) : TModalDlg("UserScal")
#else
TCurveFreeScal::TCurveFreeScal(TMDIWindow *pwnd) : TModalDlg("UserScalEng")
#endif
{
    PlotWindow = (TPlotData *)pwnd;
    //! speichern der RessourcenIDs, damit auf die Felder komfortabler
    //! zugegriffen werden kann
    FarbeId[0]=IDFarbe1;
    BereichId[0]=IDBereich1;
    FarbeId[1]=IDFarbe2;
    BereichId[1]=IDBereich2;
    FarbeId[2]=IDFarbe3;
    BereichId[2]=IDBereich3;
    FarbeId[3]=IDFarbe4;
    BereichId[3]=IDBereich4;
    FarbeId[4]=IDFarbe5;
    BereichId[4]=IDBereich5;
    FarbeId[5]=IDFarbe6;
    BereichId[5]=IDBereich6;
    FarbeId[6]=IDFarbe7;
    BereichId[6]=IDBereich7;
    FarbeId[7]=IDFarbe8;
    BereichId[7]=IDBereich8;
};

//! zum Initialisieren des Modaldialogs
BOOL TCurveFreeScal::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
{
	 char buf[MaxString];
    int i;

    //! die Funktion des neu erzeugten Fensters soll anders eingbaut werden...
    if (!PlotWindow->BSource->UserFarb) NewWindow((TMDIWindow *)new TCurveFreeScalColor(PlotWindow));

    TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);

    //! setze Intensitaeten und Farben im Dialog
    for(i=0;i<8;i++)
    {
        sprintf(buf,"%.2E",PlotWindow->BSource->ber[i]);
        SetDlgItemText(GetHandle(),BereichId[i],(LPSTR)buf);

        sprintf(buf,"%d",PlotWindow->BSource->farbe[i]);
        SetDlgItemText(GetHandle(),FarbeId[i],(LPSTR)buf);
    }
    //! setze Min und MaxIntensitaet im Dialog
    if (!GetDlgItemText(GetHandle(),ID_Max,(LPSTR)buf,10))
    {
        sprintf(buf,"%.2E",PlotWindow->UpperBound);
        SetDlgItemText(GetHandle(),ID_Max,(LPSTR)buf);
        sprintf(buf,"%.2E",PlotWindow->LowerBound);
        SetDlgItemText(GetHandle(),ID_Min,(LPSTR)buf);
    }

    return TRUE;
};

//! Ablaufsteuerung des Dialogs
void TCurveFreeScal::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
{
    char buf[MaxString];
    int i;

    switch(id)
    {
        //! im Falle von Button "Int. skalieren"
    case cm_SetupParameters:
        PlotWindow->BSource->BereichDef();
        for(i=0;i<8;i++)
        {
            sprintf(buf,"%.2E",PlotWindow->BSource->ber[i]);
            SetDlgItemText(GetHandle(),BereichId[i],(LPSTR)buf);
        }
        CanClose();
        PlotWindow->UpdateWnd(0);
        break;

        //! Return Taste bewirkt eine Ueberpruefung der Dialogeingaben
    case IDOK:
        CanClose();
        PlotWindow->UpdateWnd(0);
        break;

        //! id_Standard wird abgefangen,
        //! aufgerufen durch den OK-Button
    case id_Standard:
        if (CanClose())
        {
            LeaveDialog();
            EndDialog(hwnd,id);
        };
        PlotWindow->UpdateWnd(0);
        break;

        //! im Falle Abbrechen Button
    case IDCANCEL:
        LeaveDialog();
        EndDialog(hwnd,id);
        break;

    default:
        TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);

    }
};

//! Ueberpruefung der internen Abhaengigkeiten im Dialog
BOOL TCurveFreeScal::CanClose(void)
{
	 char buf[MaxString],Msg[MaxString];
    float valueF;
    int valuei;

    //! eingegebene Intensitaeten und Farben auf Zulaessigkeit ueberpruefen
	 for(int i=0;i<8;i++)
    {
		  GetDlgItemText(GetHandle(),BereichId[i],(LPSTR)buf,10);
        valueF=atof(buf);
        if(i==0)
        {
				if(!(PlotWindow->LowerBound<=valueF))
            {
#ifdef GermanVersion
                sprintf(Msg,"Intensittsbereich falsch!");
                MessageBox(GetFocus(),Msg,"Meldung",MBINFO);
#else
sprintf(Msg,"Intensity-area falsely!");
                MessageBox(GetFocus(),Msg,"Message",MBINFO);
#endif

                sprintf(buf,"%.2E",PlotWindow->BSource->ber[i]);
                SetDlgItemText(GetHandle(),BereichId[i],(LPSTR)buf);
                return FALSE;
            }
            else PlotWindow->BSource->ber[i]=valueF;
        }
		  else if (i==7)
        {
            if(!(PlotWindow->UpperBound>=valueF) ||
                    !(PlotWindow->BSource->ber[i-1]<=valueF))
            {
#ifdef GermanVersion
                sprintf(Msg,"Intensittsbereich falsch!");
                MessageBox(GetFocus(),Msg,"Meldung",MBINFO);
#else
sprintf(Msg,"Intensity-area falsely!");
                MessageBox(GetFocus(),Msg,"Message",MBINFO);
#endif
                sprintf(buf,"%.2E",PlotWindow->BSource->ber[i]);
                SetDlgItemText(GetHandle(),BereichId[i],(LPSTR)buf);
                return FALSE;
            }
            else PlotWindow->BSource->ber[i]=valueF;
        }
        else if (!(PlotWindow->BSource->ber[i-1]<=valueF))
        {
#ifdef GermanVersion
            sprintf(Msg,"Intensittsbereich falsch!");
            MessageBox(GetFocus(),Msg,"Meldung",MBINFO);
#else
            sprintf(Msg,"Intensity-area falsely!");
            MessageBox(GetFocus(),Msg,"Message",MBINFO);
#endif
				sprintf(buf,"%.2E",PlotWindow->BSource->ber[i]);
            SetDlgItemText(GetHandle(),BereichId[i],(LPSTR)buf);
            return FALSE;
        }
        else PlotWindow->BSource->ber[i]=valueF;

        GetDlgItemText(GetHandle(),FarbeId[i],(LPSTR)buf,10);
        valuei=atoi(buf);

        if(i==0)
        {
            if(!(0<=valuei))
            {
#ifdef GermanVersion
                sprintf(Msg,"Farbbereich falsch!");
                MessageBox(GetFocus(),Msg,"Meldung",MBINFO);
#else
                sprintf(Msg,"Color-gamut falsely!");
                MessageBox(GetFocus(),Msg,"Message",MBINFO);
#endif
                sprintf(buf,"%d",PlotWindow->BSource->farbe[i]);
                SetDlgItemText(GetHandle(),FarbeId[i],(LPSTR)buf);
                return FALSE;
            }
            else PlotWindow->BSource->farbe[i]=valuei;
        }
        else if (i==7)
		  {
            if(!(255>=valuei) ||
                    !(PlotWindow->BSource->farbe[i-1]<=valuei))
            {
#ifdef GermanVersion
                sprintf(Msg,"Farbbereich falsch!");
                MessageBox(GetFocus(),Msg,"Meldung",MBINFO);
#else
                sprintf(Msg,"Color gamut falsely!");
                MessageBox(GetFocus(),Msg,"Message",MBINFO);
#endif
                sprintf(buf,"%d",PlotWindow->BSource->farbe[i]);
                SetDlgItemText(GetHandle(),FarbeId[i],(LPSTR)buf);
                return FALSE;
            }
            else PlotWindow->BSource->farbe[i]=valuei;
        }
        else if (!(PlotWindow->BSource->farbe[i-1]<=valuei))
        {
#ifdef GermanVersion
            sprintf(Msg,"Farbbereich falsch!");
            MessageBox(GetFocus(),Msg,"Meldung",MBINFO);
#else
            sprintf(Msg,"Color gamut falsely!");
            MessageBox(GetFocus(),Msg,"Message",MBINFO);
#endif
            sprintf(buf,"%d",PlotWindow->BSource->farbe[i]);
				SetDlgItemText(GetHandle(),FarbeId[i],(LPSTR)buf);
            return FALSE;
        }
        else PlotWindow->BSource->farbe[i]=valuei;
    }

    PlotWindow->EnablePaint();
    //! Farbverteilung neu berechnen
    PlotWindow->BSource->ColorDef();
    PlotWindow->BSource->UserFarb->UpdateWnd(0);
    return TRUE;
};
BOOL TCurveFreeScal::LeaveDialog(void)
{
    PlotWindow->EnablePaint();
    return TRUE;
};

//****** Dialog zum setzen der PlotFenster-Eigenschaften ***********************
#ifdef GermanVersion
TCurveShowParam::TCurveShowParam(TMDIWindow *pwnd) : TModalDlg("DataShowParam")
#else
TCurveShowParam::TCurveShowParam(TMDIWindow *pwnd) : TModalDlg("DataShowParamEng")
#endif
{
    PlotWindow = (TPlotData *)pwnd;
    CoorSys = &PlotWindow->CoorSys;
	 AltCoorSys = &PlotWindow->AltCoorSys;
};

BOOL TCurveShowParam::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
//! initialisiert den Modaldialog fuer Visualising Options - Fehler 7,8,13
{
    //! dies nur, um laestige Warnungen auszuschalten...
    TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);

    BOOL id = 0;
    char buf[50];
    hWndOutputT = GetDlgItem(hwnd,id_ShowDataType);
    hWndScaleT = GetDlgItem(hwnd,id_ScaleTypeY);
    hWndScrolldy = GetDlgItem(hwnd,id_Bar);
    hWndScrolldx = GetDlgItem(hwnd,id_Bar2);
    scrolldypos=::RLdy;
    scrolldxpos=::RLdx;
    SetScrollRange(hWndScrolldy,SB_CTL,scrolldyposmin,scrolldyposmax,TRUE);
    SetScrollPos(hWndScrolldy,SB_CTL,scrolldypos,TRUE);
    SetScrollRange(hWndScrolldx,SB_CTL,scrolldxposmin,scrolldxposmax,TRUE);
    SetScrollPos(hWndScrolldx,SB_CTL,scrolldxpos,TRUE);

    //! Abfrage ob Ausgabefenster ein Scanfenster - dann nur Kurve zulaessig
	 //! in Combobox fuer Darstellungsart
    if(PlotWindow->WindowType == W_DiffractionWindow)
    {
        ComboBox_AddString(hWndOutputT,aOutputType[2]);
		  //! im Linescanmodus absichtlich keine Umschaltung in Kanldarstellung moeglich
        EnableWindow(GetDlgItem(hwnd,id_Z_Scala),FALSE);
    }
    else
    {
        ComboBox_AddString(hWndOutputT,aOutputType[0]);
        ComboBox_AddString(hWndOutputT,aOutputType[1]);
        ComboBox_AddString(hWndOutputT,aOutputType[2]);
    }
    ComboBox_SelectString(hWndOutputT,0,aOutputType[(PlotWindow->eOutputType-1)]);
    ComboBox_AddString(hWndScaleT,aScaleType[0]);
    ComboBox_AddString(hWndScaleT,aScaleType[1]);
    ComboBox_AddString(hWndScaleT,aScaleType[2]);

    //! Intensitaetsskalierung User nur fuer Bitmaps gueltig
	 if(PlotWindow->eOutputType <= MatrixBitmap)
    {
        ComboBox_SelectString(hWndScaleT,0,aScaleType[(CoorSys->zST-1)]);
        EnableWindow(GetDlgItem(hwnd,cm_UserScal),TRUE);
    }
    else
    {
        ComboBox_SelectString(hWndScaleT,0,aScaleType[(CoorSys->yST-1)]);
        ComboBox_DeleteString(hWndScaleT,2);
        EnableWindow(GetDlgItem(hwnd,cm_UserScal),FALSE);

    }
    //! Dialog zum Abzisse umschalten
    //! betrifft Kanaele und Winkel
    CheckDlgButton(hwnd,id_X_Scala,!PlotWindow->bSecondaryCoor); //! Winkel
    CheckDlgButton(hwnd,id_Z_Scala,PlotWindow->bSecondaryCoor); //! Kanaele

	 //! wenn kein PSD-Device als Detektor, dann Fkt. nicht waehlbar
    if(!PlotWindow->VisualDB.bPsd)
    {
        EnableWindow(GetDlgItem(hwnd,id_X_Scala),FALSE);
        EnableWindow(GetDlgItem(hwnd,id_Z_Scala),FALSE);
    }


    //! falls Intensitaeten im Dialog nicht gesetzt, mache dies
    if (!GetDlgItemText(GetHandle(),id_MaxIntensity,(LPSTR)buf,10))
    {
        sprintf(buf,"%.2E",PlotWindow->UpperBound);
        SetDlgItemText(GetHandle(),id_MaxIntensity,(LPSTR)buf);
        sprintf(buf,"%.2E",PlotWindow->LowerBound);
        SetDlgItemText(GetHandle(),id_MinIntensity,(LPSTR)buf);
    }

    //! falls dy nicht gueltig, setze dy
    GetDlgItemInt(hwnd,id_dy,(LPINT)&id,FALSE);
    if(!id) SetDlgItemInt(hwnd,id_dy,::RLdy,FALSE);

    //! falls dx nicht gueltig, setze dx
    GetDlgItemInt(hwnd,id_dx,(LPINT)&id,FALSE);
    if(!id) SetDlgItemInt(hwnd,id_dx,::RLdx,FALSE);

    //! falls tilesx,tilesy nicht gueltig, setze sie
    GetDlgItemInt(hwnd,id_tilesx,(LPINT)&id,FALSE);
    if(!id) SetDlgItemInt(hwnd,id_tilesx,tilesx,FALSE);
    GetDlgItemInt(hwnd,id_tilesy,(LPINT)&id,FALSE);
    if(!id) SetDlgItemInt(hwnd,id_tilesy,tilesy,FALSE);

	 //! groessere Punkte, xy Skalierung, y Punkte
	 CheckDlgButton(hwnd,id_Dilatation,::bIncreasePP);
	 CheckDlgButton(hwnd,id_XY_Scaling,PlotWindow->bXY_Scaling);

    //! Graustufen Checkbox setzen
	 if (PlotWindow->BSource!=NULL)
		  CheckDlgButton(hwnd,id_Graustufen,PlotWindow->BSource->bGrayScalePalette);

    //! hier geaendert, da die Fkt nur fuer RL-Bitmap gueltig sind
    if(PlotWindow->eOutputType > ReciprokeLatticeBitmap) //! > MatrixBitmap
    {
        EnableWindow(GetDlgItem(hwnd,id_XY_Scaling),FALSE);
    }
    else
    {
        EnableWindow(GetDlgItem(hwnd,id_XY_Scaling),TRUE);
    }

    if(PlotWindow->eOutputType > MatrixBitmap)
    {
        EnableWindow(GetDlgItem(hwnd,id_dy),FALSE);
        EnableWindow(GetDlgItem(hwnd,id_dx),FALSE);
		  EnableWindow(GetDlgItem(hwnd,id_Bar),FALSE);
		  EnableWindow(GetDlgItem(hwnd,id_Bar2),FALSE);
		  EnableWindow(GetDlgItem(hwnd,id_Dilatation),FALSE);
		  EnableWindow(GetDlgItem(hwnd,id_Graustufen),FALSE);
    }
    else
    {
        EnableWindow(GetDlgItem(hwnd,id_dy),TRUE);
        EnableWindow(GetDlgItem(hwnd,id_Bar),TRUE);
        EnableWindow(GetDlgItem(hwnd,id_dx),TRUE);
        EnableWindow(GetDlgItem(hwnd,id_Bar2),TRUE);
		  EnableWindow(GetDlgItem(hwnd,id_Dilatation),TRUE);
		  EnableWindow(GetDlgItem(hwnd,id_Graustufen),TRUE);
	 }

    return TRUE;
};

void TCurveShowParam::Dlg_OnHScrollBar(HWND hwnd,HWND hwndctl,UINT code,int pos)
{
	 //! Fehler 7,8
	 //! dies nur, um laestige Warnungen auszuschalten...
	 TModalDlg::Dlg_OnHScrollBar(hwnd,hwndctl,code,pos);

	 char buf[MaxString];

	 if (hwndctl==hWndScrolldy)
	 {
		  switch(code)
		  {
		  case SB_LINEUP:
		  case SB_PAGEUP:
				if (scrolldypos>scrolldyposmin)
				{
					 scrolldypos-=50;
					 ::RLdy=scrolldypos;
					 SetScrollPos(hWndScrolldy,SB_CTL,scrolldypos,TRUE);
					 sprintf(buf,"%d",::RLdy);
					 SetDlgItemText(hwnd,id_dy,(LPSTR)buf);
				}
				break;

		  case SB_LINEDOWN:
		  case SB_PAGEDOWN:
				if (scrolldypos<scrolldyposmax)
				{
					 scrolldypos+=50;
					 ::RLdy=scrolldypos;
					 SetScrollPos(hWndScrolldy,SB_CTL,scrolldypos,TRUE);
					 sprintf(buf,"%d", ::RLdy);
					 SetDlgItemText(hwnd,id_dy,(LPSTR)buf);
				}
				break;

				/* case SB_THUMBPOSITION:
				 break;

				 case SB_ENDSCROLL:
				 break;
				*/
		  }
	 }

	 if (hwndctl==hWndScrolldx)
	 {
		  switch(code)
		  {
		  case SB_LINEUP:
		  case SB_PAGEUP:
				if (scrolldxpos>scrolldxposmin)
				{
					 scrolldxpos-=50;
					 ::RLdx=scrolldxpos;
					 SetScrollPos(hWndScrolldx,SB_CTL,scrolldxpos,TRUE);
					 sprintf(buf,"%d",::RLdx);
					 SetDlgItemText(hwnd,id_dx,(LPSTR)buf);
				}
				break;

		  case SB_LINEDOWN:
		  case SB_PAGEDOWN:
				if (scrolldxpos<scrolldxposmax)
				{
					 scrolldxpos+=50;
					 ::RLdx=scrolldxpos;
					 SetScrollPos(hWndScrolldx,SB_CTL,scrolldxpos,TRUE);
					 sprintf(buf,"%d",::RLdx);
					 SetDlgItemText(hwnd,id_dx,(LPSTR)buf);
				}
				break;

				/* case SB_THUMBPOSITION:
				 break;

				 case SB_ENDSCROLL:
				 break;
				*/
		  }
	 }
};

#pragma argsused
void TCurveShowParam::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
//! behandelt das Untermenu Visualising Options und reagiert auf
//! AEnderungen in Menueintraegen mit entsprechenden Reaktionen - Fehler 7,8,13
{
    //! char userbuf[]="User";

    switch(id)
    {
        //! betrifft Button User Skalierung
    case cm_UserScal:
        PlotWindow->UpdateWnd(0);
        FreeScaldlg = (TCurveFreeScal *)new TCurveFreeScal((TPlotData *)PlotWindow);
        FreeScaldlg->ExecuteDialog(hwnd);
        delete FreeScaldlg;
        PlotWindow->UpdateWnd(0);
        break;

        //! betrifft Button "Neuzeichnen"
    case cm_SetupParameters:
        CanClose();
        PlotWindow->UpdateWnd(0);
        break;

        //! IDOK wird abgefangen, da ein "Enter" auch ein IDOK liefert...
        //! aber hier Beenden des Dialogs unerwuenscht, aber Aktualisierung
        //! der Darstellung erfolgt
    case IDOK:
        CanClose();
        PlotWindow->UpdateWnd(0);
        break;

        //! id_Standard wird abgefangen,
        //! aufgerufen durch den OK-Button
    case id_Standard:
        CanClose();
        PlotWindow->UpdateWnd(0);
        LeaveDialog();
        EndDialog(hwnd,id);
        break;

    case IDCANCEL:
        LeaveDialog();
        EndDialog(hwnd,id);
        break;

        /* case id_ScaleTypeY:

         switch(codeNotify)
         {
         case CBN_SELCHANGE:
         {
         retval = ComboBox_GetCurSel(hWndScaleT);
         if(retval != CB_ERR)
         {
         switch(retval+1)
         {
         case Logarithmic:
         case Linear:
         EnableWindow(GetDlgItem(hwnd,id_MaxIntensity),TRUE);
         EnableWindow(GetDlgItem(hwnd,id_MinIntensity),TRUE);
         break;

         case User:
         EnableWindow(GetDlgItem(hwnd,id_MaxIntensity),FALSE);
         EnableWindow(GetDlgItem(hwnd,id_MinIntensity),FALSE);
         break;
         }
         }
         }
         }
        */
    case id_ShowDataType:
        //! betrifft Combobox zur Auswahl der Darstellungsart
        //! hier geaendert, da die Fkt nur fuer RL-Bitmap gueltig sind
        //! nur fuer RL-Bitmap werden Menupunkte xy Skalierung, y-Punkte,
        //! groessere Punkte sichtbar
        switch(codeNotify)
        {
        case CBN_SELCHANGE:
            {
                if(PlotWindow->WindowType != W_DiffractionWindow)
                {
                    retval = ComboBox_GetCurSel(hWndOutputT);
                    if(retval != CB_ERR)
                    {
                        switch(1+retval)
                        {
                        case MatrixBitmap:
                            EnableWindow(GetDlgItem(hwnd,id_Dilatation),TRUE);
									 EnableWindow(GetDlgItem(hwnd,id_XY_Scaling),FALSE);
									 EnableWindow(GetDlgItem(hwnd,id_Graustufen),TRUE);
                            EnableWindow(GetDlgItem(hwnd,id_dy),TRUE);
                            EnableWindow(GetDlgItem(hwnd,id_Bar),TRUE);
                            EnableWindow(GetDlgItem(hwnd,id_dx),TRUE);
                            EnableWindow(GetDlgItem(hwnd,id_Bar2),TRUE);
                            if (CB_ERR==ComboBox_FindString(hWndScaleT,0,aScaleType[User-1]))
										  ComboBox_AddString(hWndScaleT,aScaleType[User-1]);
									 break;

								case Curve:
									 EnableWindow(GetDlgItem(hwnd,id_Dilatation),FALSE);
									 EnableWindow(GetDlgItem(hwnd,id_XY_Scaling),FALSE);
									 EnableWindow(GetDlgItem(hwnd,id_Graustufen),FALSE);
									 EnableWindow(GetDlgItem(hwnd,id_dy),FALSE);
									 EnableWindow(GetDlgItem(hwnd,id_Bar),FALSE);
									 EnableWindow(GetDlgItem(hwnd,id_dx),FALSE);
									 EnableWindow(GetDlgItem(hwnd,id_Bar2),FALSE);

									 retval = ComboBox_GetCurSel(hWndScaleT);
									 if(CB_ERR!=retval)
									 {
										  switch(retval+1)
										  {
										  case User:
												CoorSys->yST = Logarithmic;
												ComboBox_SelectString(hWndScaleT,0,aScaleType[Logarithmic-1]);
												break;
										  }
									 }
									 if (CB_ERR!=ComboBox_FindString(hWndScaleT,0,aScaleType[User-1]))
										  ComboBox_DeleteString(hWndScaleT,User-1);
									 break;

								case ReciprokeLatticeBitmap:
									 EnableWindow(GetDlgItem(hwnd,id_Dilatation),TRUE);
									 EnableWindow(GetDlgItem(hwnd,id_XY_Scaling),TRUE);
                            EnableWindow(GetDlgItem(hwnd,id_Graustufen),TRUE);
                            EnableWindow(GetDlgItem(hwnd,id_dy),TRUE);
                            EnableWindow(GetDlgItem(hwnd,id_Bar),TRUE);
                            EnableWindow(GetDlgItem(hwnd,id_dx),TRUE);
                            EnableWindow(GetDlgItem(hwnd,id_Bar2),TRUE);

                            if (CB_ERR==ComboBox_FindString(hWndScaleT,0,aScaleType[User-1]))
                                ComboBox_AddString(hWndScaleT,aScaleType[User-1]);
                            break;
                        }
                    }
                    else break;
                }
                else break;
            }

        default:
            TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
        }
    }
};

BOOL TCurveShowParam::CanClose(void)
//! bereitet Daten zum Schliessen oder Neuzeichnen des Plotwindows auf
//! Fehler 7,8,9,10,13
{
    char buf[MaxString];
    float valueF;
    BOOL id = 0;

    //! waehle Ausgabetyp und setze Parameter entsprechend
    retval = ComboBox_GetCurSel(hWndOutputT);
    if(retval != CB_ERR)
    {
        if(PlotWindow->WindowType != W_DiffractionWindow)
        {
            switch(1+retval)
            {
            case Curve:
                CoorSys = &PlotWindow->CoorSys;
                PlotWindow->eOutputType = Curve;
                retval=1+ComboBox_GetCurSel(hWndScaleT);
                if (retval==1) CoorSys->yST = Logarithmic;
                else if (retval==2) CoorSys->yST = Linear;
                break;

            case MatrixBitmap:
                CoorSys = &PlotWindow->CoorSys;
                if(Main.AreaScanWindow != PlotWindow) break;
                PlotWindow->eOutputType = MatrixBitmap;
                CoorSys->yST = Linear;
                retval=1+ComboBox_GetCurSel(hWndScaleT);
                if (retval==1) CoorSys->zST = Logarithmic;
                else if (retval==2) CoorSys->zST = Linear;
                else CoorSys->yST=User;
                break;

            case ReciprokeLatticeBitmap:
                CoorSys = &PlotWindow->CoorSys;
					 // CoorSys = &PlotWindow->AltCoorSys;
					 if(Main.AreaScanWindow != PlotWindow) break;
					 PlotWindow->eOutputType = ReciprokeLatticeBitmap;
					 CoorSys->yST = Linear;
					 retval=1+ComboBox_GetCurSel(hWndScaleT);
					 if (retval==1) CoorSys->zST = Logarithmic;
					 else if (retval==2) CoorSys->zST = Linear;
					 else CoorSys->yST=User;
					 break;
				}
		  }
		  else PlotWindow->eOutputType = Curve;
	 }

	 //! erzeuge neues TBitmapSourceObjekt wenn noetig
	 if (PlotWindow->eOutputType<=MatrixBitmap)
	 {
		  if(!PlotWindow->bBitmapIsCreated)
		  {
				new TBitmapSource((TPlotData *)PlotWindow);
				PlotWindow->bBitmapIsCreated = TRUE;
		  }
		  EnableWindow(GetDlgItem(GetHandle(),cm_UserScal),TRUE);
	 }
	 else EnableWindow(GetDlgItem(GetHandle(),cm_UserScal),FALSE);

	 PlotWindow->DisablePaint();

	 //! bewirkt ob an der Abzisse Kanaele oder Winkel abgetragen...
	 PlotWindow->bSecondaryCoor = IsDlgButtonChecked(GetHandle(),id_Z_Scala);

	 if (PlotWindow->eOutputType==ReciprokeLatticeBitmap)
	 {
		 PlotWindow->bSecondaryCoor=FALSE;
		 EnableWindow(GetDlgItem(GetHandle(),id_Z_Scala),FALSE);
		 EnableWindow(GetDlgItem(GetHandle(),id_X_Scala),FALSE);
		 CheckDlgButton(GetHandle(),id_Z_Scala,PlotWindow->bSecondaryCoor);
		 CheckDlgButton(GetHandle(),id_X_Scala,!PlotWindow->bSecondaryCoor);
	 }
	 else if (PlotWindow->VisualDB.bPsd)
	 {
		 EnableWindow(GetDlgItem(GetHandle(),id_X_Scala),TRUE);
		 EnableWindow(GetDlgItem(GetHandle(),id_Z_Scala),TRUE);
		 CheckDlgButton(GetHandle(),id_Z_Scala,PlotWindow->bSecondaryCoor);
		 CheckDlgButton(GetHandle(),id_X_Scala,!PlotWindow->bSecondaryCoor);
	 }

	 //! hier werden Felder id_tilesx, id_tilesy abgefragt
	 valueF=GetDlgItemInt(GetHandle(),id_tilesx,(LPINT)&id,FALSE);
	 if(!id) SetDlgItemInt(GetHandle(),id_tilesx,tilesx,FALSE);
	 else if (2<=valueF && valueF<=15) tilesx=valueF;
	 else
	 {
		  SetDlgItemInt(GetHandle(),id_tilesx,tilesx,FALSE);
#ifdef GermanVersion
		  MessageBox(GetFocus(),"Werte fuer Abzisseneinteilung 2 - 15","Meldung",MBINFO);
#else
MessageBox(GetFocus(),"Values for x-axle organization 2 - 15","Message",MBINFO);
#endif
	 }
	 valueF=GetDlgItemInt(GetHandle(),id_tilesy,(LPINT)&id,FALSE);
	 if(!id) SetDlgItemInt(GetHandle(),id_tilesy,tilesy,FALSE);
	 else if (2<=valueF && valueF<=15) tilesy=valueF;
	 else
	 {
		  SetDlgItemInt(GetHandle(),id_tilesy,tilesy,FALSE);
#ifdef GermanVersion
		  MessageBox(GetFocus(),"Werte fuer Ordinateneinteilung 2 - 15","Meldung",MBINFO);
#else
		  MessageBox(GetFocus(),"Values for y-axle organization 2 - 15","Message",MBINFO);
#endif
	 }

	 //! hier jetzt Abfrage der Min und Max Werte fuer Intensitaeten
	 //! es werden nur zulaessige Intensitaeten zugelassen
	 //! die hier setzt bei keinen Werten im Fenster Werte entsprechend

	 GetDlgItemText(GetHandle(),id_MaxIntensity,(LPSTR)buf,10);
	 valueF = atof(buf);
	 if(valueF <= MaxIntensitaet) PlotWindow->UpperBound = valueF;
    else
    {
        sprintf(buf,"%.2E",PlotWindow->UpperBound);
        SetDlgItemText(GetHandle(),id_MaxIntensity,(LPSTR)buf);
#ifdef GermanVersion
        MessageBox(GetFocus(),"gewhlte Intensitt zu gro","Meldung",MBINFO);
#else
        MessageBox(GetFocus(),"selected intensity excessively","Message",MBINFO);
#endif

    }
    GetDlgItemText(GetHandle(),id_MinIntensity,(LPSTR)buf,10);
    valueF = atof(buf);
    if(valueF >= MinIntensitaet) PlotWindow->LowerBound = valueF;
    else
    {
        sprintf(buf,"%.2E",PlotWindow->LowerBound);
        SetDlgItemText(GetHandle(),id_MinIntensity,(LPSTR)buf);
#ifdef GermanVersion
        MessageBox(GetFocus(),"gewhlte Intensitt zu klein","Meldung",MBINFO);
#else
        MessageBox(GetFocus(),"selected intensity too small","Message",MBINFO);
#endif
    }
    if(PlotWindow->LowerBound >= PlotWindow->UpperBound)
    {
        PlotWindow->UpperBound = MaxIntensitaet;
        PlotWindow->LowerBound = MinIntensitaet;
        sprintf(buf,"%.2E",PlotWindow->UpperBound);
        SetDlgItemText(GetHandle(),id_MaxIntensity,(LPSTR)buf);
        sprintf(buf,"%.2E",PlotWindow->LowerBound);
        SetDlgItemText(GetHandle(),id_MinIntensity,(LPSTR)buf);
#ifdef GermanVersion
        MessageBox(GetFocus(),"MinIntensitt grer als MaxIntensitt","Meldung",MBINFO);
#else
        MessageBox(GetFocus(),"Min intensity more largely than max intensity","Message",MBINFO);
#endif
    }

    //! pruefe CheckButtons "groessere Punkte", "x-y Skalierung"
	 ::bIncreasePP = IsDlgButtonChecked(GetHandle(),id_Dilatation);
	 PlotWindow->bXY_Scaling = IsDlgButtonChecked(GetHandle(),id_XY_Scaling);

	 if (PlotWindow->BSource!=NULL)
	     PlotWindow->BSource->bGrayScalePalette=IsDlgButtonChecked(GetHandle(),id_Graustufen);

    //! waehle Intensitaetsskalierung und setze Parameter entsprechend
    retval = ComboBox_GetCurSel(hWndScaleT);
    if(retval != CB_ERR)
    {
        switch(retval+1)
        {
        case Logarithmic:
            if(PlotWindow->eOutputType <= MatrixBitmap)
            {
                CoorSys->zST = Logarithmic;
                CoorSys->yST = Linear;
            }
            else
                CoorSys->yST = Logarithmic;
            break;
        case Linear:
            CoorSys->yST = Linear;
            CoorSys->zST = Linear;
            break;

        case User:
            if(PlotWindow->eOutputType <= MatrixBitmap)
            {
                CoorSys->zST = User;
                CoorSys->yST = Linear;
            }
            else
                CoorSys->yST = User;

            break;
        }
    }

    //! wenn irgendein Bitmap, muss aktualisiert werden...
    if(PlotWindow->eOutputType<=MatrixBitmap)
    {
        //! zu Fehler 12
        PlotWindow->Screen.dy=stdy;
        PlotWindow->Screen.dx=stdx;

        PlotWindow->BSource->FormatDBaseToBitmapSource();
    }
    PlotWindow->EnablePaint();

    return TRUE;
};

BOOL TCurveShowParam::LeaveDialog(void)
//! der Name sagt alles...
//! wird im Falle von Dlg_OnCommand --> (IDOK), IDABORT und IDCANCEL aufgerufen
//! in dlg_tpl.cpp, was zu tun fuer Nachricht IDOK selbst neu definiert
{
    /* if(PlotWindow->eOutputType <= MatrixBitmap)
     {
     CoorSys = &PlotWindow->CoorSys;
     CoorSys->yST = CoorSys->xST = Linear;
     }*/
    PlotWindow->EnablePaint();
    return TRUE;
};

//! Konstruktor
TCurveFreeScalColor::TCurveFreeScalColor(TMDIWindow *pwnd):TMDIWindow()
{
    //! Registrieren der Kindfenster-Klasse
    TMDIWindow::RegisterWnd();
    PlotWindow = (TPlotData *)pwnd;
    PlotWindow->BSource->UserFarb = this;
}

//! Destruktor
TCurveFreeScalColor::~TCurveFreeScalColor()
{
    char buf[MaxString];
    RECT rc, rcm;

    GetWindowRect(GetFrameHandle(),&rcm );
    GetWindowRect(hWndChild,&rc);
    sprintf(buf,"%d",rc.left-rcm.left-4);
    WritePrivateProfileString("UserScal","xo",buf,GetCFile());
    sprintf(buf,"%d",rc.top-rcm.top-42 );
    WritePrivateProfileString("UserScal","yo",buf,GetCFile());
    PlotWindow->BSource->UserFarb=NULL;
}

//! Titel setzen
BOOL TCurveFreeScalColor::SetTitle()
{
    char aTitle[MaxString];
#ifdef GermanVersion
    strcpy( aTitle, "User Skalierung - Farbwahl" );
#else
    strcpy( aTitle, "User scaling - color choice" );
#endif
    SetWindowText(hWndChild, aTitle);
    return TRUE;
};

//! neues Fenster bauen
void TCurveFreeScalColor::Create(HWND hwnd)
{
    RECT rc;

    hWndChild=hwnd;
    //! lese ini-File fuer Fensterposition
    rc.left=GetPrivateProfileInt("UserScal","xo",0,GetCFile());
    rc.top=GetPrivateProfileInt("UserScal","yo",0,GetCFile());
    SetWindowPos(hWndChild,HWND_TOP,rc.left,rc.top,375,325,SWP_NOZORDER);
    SetTitle();
}

//! wenn Fensterinhalt neu gezeichnet werden muss
void TCurveFreeScalColor::Paint(HDC hdc,PAINTSTRUCT *)
{
    DrawColorTable(hdc);
}

//! zeichnet den Inhalt des Fensters
void TCurveFreeScalColor::DrawColorTable(HDC hdc)
{
    int cnt,crange,yrand=20,xlrand=50,xrrand=80,fs=14,i;
    int red,green,blue;
    LOGPALETTE *pPal;
    PALETTEENTRY *pPE;
    char buf[30];
    HBRUSH hBrush,hBrushOld;
    HPEN hPen,hPenOld;
    POINT aPoints[5];
    HPALETTE hPal,hDefPal;
    HFONT hFont,hOldFont;
    LOGFONT lf;
    SIZE tagS;
    TBitmapSource* BitmapSource;

    BitmapSource=PlotWindow->BSource;

    //! Font selektieren
    memset(&lf,0,sizeof(LOGFONT));
    lf.lfHeight = fs;
    lf.lfWidth = 0;
    lf.lfWeight = 200;
    lf.lfUnderline = FALSE;
    strcpy(lf.lfFaceName,"Times New Roman");
    hFont = CreateFontIndirect(&lf);
    hOldFont = (HFONT)SelectObject(hdc,hFont);

    //! Palette aufbauen
    pPal = BitmapSource->GetPalette();
    hPal = CreatePalette(pPal);
    hDefPal = SelectPalette(hdc,hPal,FALSE);
    RealizePalette(hdc);

    pPE = pPal->palPalEntry;
    crange=BitmapSource->ColorTable.nColorRange;

    //! male Farbverlauf
    for(cnt=crange;cnt>-1;cnt--)
    {
        red = pPE[cnt].peRed;
        green = pPE[cnt].peGreen;
        blue = pPE[cnt].peBlue;
        hBrush = CreateSolidBrush(RGB(red,green,blue));
        if (cnt==crange) hBrushOld = (HBRUSH)SelectObject(hdc,hBrush);
        hPen = CreatePen(PS_SOLID,1,RGB(red,green,blue));
        if (cnt==crange) hPenOld = (HPEN)SelectObject(hdc,hPen);


        gdiobj = SelectObject(hdc,hBrush);
        gdiobj = SelectObject(hdc,hPen);

        //! male Markierungen rechts am Farbverlauf
        aPoints[0].y=aPoints[1].y=crange-cnt+yrand;
        aPoints[0].x=xlrand;
        aPoints[1].x=xrrand;

        Polyline(hdc,aPoints,2);
        SetTextAlign(hdc,TA_TOP);
        SelectObject(hdc,hBrushOld);
        retval = DeleteObject(hBrush);
        SelectObject(hdc,hPenOld);
        retval = DeleteObject(hPen);

        //! male Markierungen fuer "reine Farben"
        if (crange-cnt==0 || crange-cnt==51 || crange-cnt==101 ||
                crange-cnt==151 || crange-cnt==201 || crange-cnt==255)
        {
            SetTextAlign(hdc,TA_LEFT);
#ifdef GermanVersion
            sprintf(buf,"Farbe %d",crange-cnt);
#else
            sprintf(buf,"Color %d",crange-cnt);
#endif
            GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
            TextOut(hdc,xrrand+10,cnt+yrand-(lf.lfHeight/2),(LPSTR)buf,strlen(buf));

            hPen = CreatePen(PS_SOLID,1,RGB(0,0,0));
            hPenOld = (HPEN)SelectObject(hdc,hPen);
            aPoints[0].x=xrrand;
            aPoints[0].y=aPoints[1].y=cnt+yrand;
            aPoints[1].x=xrrand+5;
            Polyline(hdc, aPoints,2);
            SelectObject(hdc,hPenOld);
            retval = DeleteObject(hPen);
        }
    }
    //! schreibe links und rechts oben Text aus...
    SetTextAlign(hdc,TA_LEFT);
#ifdef GermanVersion
    sprintf(buf,"Int.bereiche");
#else
    sprintf(buf,"Int.areas");
#endif
    GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
    TextOut(hdc,xlrand-40,yrand-17,(LPSTR)buf,strlen(buf));

#ifdef GermanVersion
    sprintf(buf,"Intensitten");
#else
    sprintf(buf,"Intensities");
#endif
    GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
    TextOut(hdc,xrrand+200,yrand-17,(LPSTR)buf,strlen(buf));

    hPen = CreatePen(PS_SOLID,1,RGB(0,0,0));
    hPenOld = (HPEN)SelectObject(hdc,hPen);

    //! male und schreibe Farben und Intensitaeten
    for(i=0;i<8;i++)
    {
        aPoints[0].x=xlrand;
        aPoints[0].y=aPoints[1].y=crange-BitmapSource->farbe[i]+yrand;
        aPoints[1].x=xlrand-5;
        Polyline(hdc,aPoints,2);
        SetTextAlign(hdc,TA_LEFT);
        sprintf(buf,"%d",i+1);
        GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
        if(i%2)TextOut(hdc,xlrand-15,crange-BitmapSource->farbe[i]+yrand-(lf.lfHeight/2),(LPSTR)buf,strlen(buf));
        else TextOut(hdc,xlrand-25,crange-BitmapSource->farbe[i]+yrand-(lf.lfHeight/2),(LPSTR)buf,strlen(buf));

        red = pPE[BitmapSource->farbe[i]].peRed;
        green = pPE[BitmapSource->farbe[i]].peGreen;
        blue = pPE[BitmapSource->farbe[i]].peBlue;
        hBrush = CreateSolidBrush(RGB(red,green,blue));
        hBrushOld = (HBRUSH)SelectObject(hdc,hBrush);

        gdiobj = SelectObject(hdc,hBrush);
        gdiobj = SelectObject(hdc,hPen);

        Rectangle(hdc,xrrand+180,crange+yrand-i*32,xrrand+200,crange+yrand-20-i*32);

        SelectObject(hdc,hBrushOld);
        retval = DeleteObject(hBrush);

        SetTextAlign(hdc,TA_LEFT);
#ifdef GermanVersion
        sprintf(buf,"Bereich %d -> Farbe",i+1);
#else
        sprintf(buf,"Area %d -> Color",i+1);
#endif
        GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
        TextOut(hdc,xrrand+90,crange+yrand-i*32-(lf.lfHeight/2)-10,(LPSTR)buf,strlen(buf));
        sprintf(buf,"%.2f",BitmapSource->ber[i]);
        GetTextExtentPoint(hdc,buf,strlen(buf),&tagS);
        TextOut(hdc,xrrand+210,crange+yrand-i*32-(lf.lfHeight/2)-10,(LPSTR)buf,strlen(buf));
    }
    //! zeichne Rand um Farbskala
    aPoints[0].x=aPoints[1].x=aPoints[4].x=xlrand;
    aPoints[0].y=aPoints[3].y=aPoints[4].y=yrand;
    aPoints[1].y=aPoints[2].y=crange+yrand+1;
    aPoints[2].x=aPoints[3].x=xrrand;

    Polyline(hdc, aPoints, sizeof(aPoints) / sizeof(POINT));

    SelectObject(hdc,hPenOld);
    retval = DeleteObject(hPen);
    gdiobj = SelectObject(hdc,hOldFont);
    retval = DeleteObject(hFont);

    SelectPalette(hdc,hDefPal,FALSE);
    DeleteObject(hPal);
};
// __LastLine__


