#ifndef __AUTOJUST_H
#define __AUTOJUST_H

// Die Matrix-Bibliothek wurde fr Borland C++ 5.0,das den C++-Standardtyp bool
// fr Boolean-Variablen untersttzt. Um die Bibliothek aber unter
// Borland C++ 4.5 bersetzen zu knnen, mssen die folgenden
// include/define Zeilen eingeschoben werden
// __BCPLUSPLUS__ gibt die Versionsnummer des Compilers an
// und hat unter BC4.5 den Wert 0x340 und unter BC5.02 den Wert 0x520
#ifdef __BCPLUSPLUS__
  #if ( __BCPLUSPLUS__ <= 0x340 )
    #define bool  int
    #define false 0
    #define true  1
  #endif
#endif

// Struktur, die die Positionen der Motoren der
// bestimmten Antriebsachsen aufnimmt (OrigDF/TL/CC)
// zustzlich werden die Intervallschranken, innerhalb
// derer die Optimierung durchgefhrt wird, gespeichert
// (Min/MaxDF/TL/CC)
typedef struct
{
  double MinDF; double MaxDF; double OrigDF;
  double MinTL; double MaxTL; double OrigTL;
  double MinCC; double MaxCC; double OrigCC;
} TMotorPositionsWerte;

// Struktur, in der die Intensitt (Intensity)
// an einer bestimmten Position (DF,TL,CC) gespeichert wird
typedef struct
{
  double DF; double TL; double CC;
  float Intensity;
} TIntensityPosition;

class TransformationClass;

// Dialogklasse der Automatischen Justage
class TAutomaticAngleControl : public TModalDlg
{
 public:
           TAutomaticAngleControl();
  BOOL     Dlg_OnInit ( HWND, HWND, LPARAM );
  void     Dlg_OnCommand( HWND, int, HWND, UINT );
  BOOL     LeaveDialog(void);


 private:
  // Tranformationsobjekt als Member definiert
  TransformationClass *Transform;

  TDevice* Sensor;
  
  // Inhalt des Statusfeldes
  char * status;
  
  //Aktivierung der Abbruchkriteriums Intensittsdifferenz
  bool bIntensityDiffActive;
  
  // maximale Groesse fuer das Status-Textfeld
  unsigned nMaxString;
  
  // Temporre Buffer zur Stringzusammensetzung
  char *buf, *buf1;

  // Laufvariablen
  int durchlauf,step,step1,count;
  
  // Anzahl der Zeilen im Status-Textfeld
  DWORD dwStatusZeilen;
  
  // Zahl der durchzufhrenden Messungen pro Position
  unsigned nMeasureCount;
  
  // Positionsvariablen, Intensittsvariablen
  double fPosition, intervall_li, intervall_re, x,y,z,x2,y2,z2;
  double MaxTL,MaxDF,MaxCC;
  float fIntenseDifferenz;
  
  // Variablen zur Ausgabe der Justagedauer
  struct date datum;
  struct time zeit;
  int justageanfang, justageende, justagezeit;
  
  // Variablen zur Speicherung der Wertebereiche & Intensittspositionen
  TMotorPositionsWerte Wertebereich, aktWertebereich;
  TIntensityPosition MaxIntensity, LastIntensity, ActIntensity;
};

#endif