#ifndef _M_SCAN_H_
#define _M_SCAN_H_


class TSetupContinuousScan : public TModalDlg
{
public:
	 TSetupContinuousScan( TScan* );

private:
	 //! handles auf motor/detektor-comboboxen
	 HWND hDeviceList, hMotorList;

	 //! Nummer des ausgewaehlten Motors
	 int  nMotor;

	 //! Zeiger auf ausgewaehlten Detektor
	 TDevice* Device;

	 //! Zeiger auf zugehoeriges StepScanfenster
	 TScan* Scan;

	 //! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen
	 //! der Dialogbox (durch OK-Button)
	 //! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann
	 //! (Werte inkonsistent) Werte werden nicht uebernommen
	 //! sonst true
	 BOOL CanClose( void );

	 //! behandelt alle kommandos der Dialogbox
	 void Dlg_OnCommand( HWND, int, HWND, UINT );

	 //! setzen der Defaultwerte der Dialogbox
	 //! rueckkehrcode: immer true
	 BOOL Dlg_OnInit( HWND, HWND, LPARAM );

	 double //! Wert Startpunkt in Dlg.box
	 dArgumentMin,
	 //! Wert Endpunkt in Dlg.box
	 dArgumentMax,
	 //! Wert Geschwindigkeit in Dlg.box
	 dSpeed;

	 //! Bereichsgroesse
	 double dArgumentWidth;

	 //! Wert Messpunkte in Dlg.box
	 int nCollectionAmount;

	 //! Wert Messzeit in Dlg.box
	 float fMaxTime;

	 //! automatisch Speichern nach Beendigung der Messung
	 BOOL bSaveOnReady;

};



class TSetupStepScan : public TModalDlg
{
public:
	 TSetupStepScan( TScan* );

private:
    //! handles auf motor/detektor-Comboboxen
    HWND hDeviceList;
	 HWND hMotorList;

    //! handle auf Scantyp-combobox
    HWND hScanTypeList;

    int //! akt. Motor
    nMotor,
    //! ?? ueberfluessig
    nOldMotor;

    //! akt. detektoren fuer Messung und Monitor
    LPDevice Device, Monitor;

    //! zugehoeriges StepScanfenster
    TScan* Scan;

	 //! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen
	 //! der Dialogbox (durch OK-Button)
	 //! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann
	 //! (Werte inkonsistent) sonst true
	 BOOL CanClose( void );

	 //! behandelt alle kommandos der Dialogbox
	 void Dlg_OnCommand( HWND, int, HWND, UINT );

	 //! setzen der Defaultwerte der Dialogbox
	 //! rueckkehrcode: immer true
	 BOOL Dlg_OnInit( HWND, HWND, LPARAM );

	 //! ?? ueberfluessig da vererbt
	 //! rueckkehrcode: immer true
	 BOOL LeaveDialog( void )
    {
        return TRUE;
    };

    double //! Wert Minimum in Dlg.box
    dArgumentMin,
    //! Wert Maximum in Dlg.box
    dArgumentMax,
    //! Wert Schrittweite in Dlg.box
    dArgumentWidth;

    //! ?? nicht verwendet
    int nMotorOld;

    //! ?? nicht verwendet
    LPDevice DeviceOld;

    //! ?? nicht verwendet
    LPDevice MonitorOld;

    //! Wert Impulse in Dlg.box
    DWORD dwMaxCounts;

    //! Wert Zeit in Dlg.box
	 float fMaxTime;

    BOOL //! ?? scheinbar ueberfluessig
	 bMonitor,
    //! Wert Bei Beenden speichern
    bSaveOnReady;

    //! ?? ueberfluessig
    TSaveFormat eSaveFormat;

    //! Wert Scan-Typ in Dlg.box
    TxScanType eScanType;

    //! Wert Staendig Sichern in Dlg.box
    BOOL bSaveContinuous;

    //! Wert Monitor-Signal in Dlg.box
    BOOL bMonitorUsed;

    //! Wert Sicherungsverzeichnis
    char szPath[ 2*MaxString ];

    //! Wert 2Theta
	 double d2ThetaStart;


};

//! Aenderung Dynamische Schrittweite
//! Dialogbox-Klasse fuer Einstellungen Dynamische Schrittweite
class TSetupDynamicStep : public TModalDlg
{
public:
	 TSetupDynamicStep( TScan* );

private:
	 //! zugehoeriges StepScanfenster
	 TScan* Scan;

	 //! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen
	 //! der Dialogbox (durch OK-Button)
	 //! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann
	 //! (Werte inkonsistent) sonst true
	 BOOL CanClose( void );

	 //! behandelt alle kommandos der Dialogbox
	 void Dlg_OnCommand( HWND, int, HWND, UINT );

	 //! setzt Defaultwerte der Dialogbox bei Aufruf der Box
	 //! Rueckkehrcode immer true
	 BOOL Dlg_OnInit( HWND, HWND, LPARAM );

	 //! zur Sicherung der Dialogbox-Einstellungen, um sie bei Reset zurcksetzen
	 //! zu koennen
	 float ScalerDummy[20];

	 //! zur komfortableren Arbeit mit Resourcen-Id's
	 int IntensityId[10];
	 int FactorId[10];
   int StaticId[10];
};

#endif